require.config({
    paths: {
        'react': '/module/easyBinding/rc/node_modules/react/dist/react-with-addons',
        'react-dom': '/module/easyBinding/rc/node_modules/react-dom/dist/react-dom',
        'myD3': '/module/easyBinding/rc/node_modules/d3/dist/d3.min'
    }
});

define(
    [
        'jquery',
        'baja!',
        'bajaux/Widget',
        'bajaux/mixin/subscriberMixIn',
        'react',
        'react-dom',
        'myD3',
        'nmodule/easyBinding/rc/widgetJS/js/EasyWidget',
        'css!nmodule/easyBinding/rc/EasyWidget/EasyWidget'
    ],
    function ($,
        baja,
        Widget,
        subscriberMixIn,
        react,
        reactDOM,
        myD3,
        easyWidgetFileRenderDOM
    ) {

        var EasyWidget = function () {
            var that = this;
            // This calls the super constructor.
            Widget.apply(that, arguments);

            that.properties().add({
                name: "data",
                value: "{}",
                hidden: true
            });
            that.properties().add({
                name: "alarmOrd",
                value: "",
                hidden: true
            });
            that.properties().add({
                name: "overrideOrd",
                value: "",
                hidden: true
            });
            that.properties().add({
                name: "valueOrd",
                value: "",
                hidden: true
            });
            that.properties().add({
                name: "labelOnly",
                value: false
            });
            that.properties().add({
                name: "showValue",
                value: true
            });
            that.properties().add({
                name: "showAlarm",
                value: true
            });
            that.properties().add({
                name: "showOverride",
                value: true
            });
            that.properties().add({
                name: "labelPosition",
                value: "bottom",
                typeSpec: "easyBinding:EbLabelPosEnum"
            });
            that.properties().add({
                name: "images",
                value: "",
                typeSpec: "baja:Ord"
            });

            // Applying a Subscriber MixIn adds subscription capabilities to a
            // Widget. Once added, the value passed into 'doLoad' is fully subscribed
            // and 'live'.
            subscriberMixIn(that);
        };

        var easyWidgetlogBajaInfo=function(info,isError){
             if(isError) {
                baja.outln("Error:" +info);
            }else {
                baja.outln("Info:" + info);
            }
        }

        //extend and set up prototype chain
        EasyWidget.prototype = Object.create(Widget.prototype);
        EasyWidget.prototype.constructor = EasyWidget;
        EasyWidget.hiddenValue = null;
        EasyWidget.prototype.doInitialize = function (element) {
            var that = this;
            element.addClass("d3_EasyWidgetOuter");

            //subscribe our values
            var valueOrd = that.properties().getValue("valueOrd");
            var alarmOrd = that.properties().getValue("labelOnly") ? that.properties().getValue("valueOrd") : that.properties().getValue("alarmOrd");
            var overrideOrd = that.properties().getValue("labelOnly") ? that.properties().getValue("valueOrd") : that.properties().getValue("overrideOrd");

            if (valueOrd != "" && valueOrd != undefined) {
                var sub = new baja.Subscriber();
                sub.attach("changed", function (val) {
                    const facets = this.getFacets1().$map.$map;
                    switch (this.getType().toString()) {
                        case "control:BooleanWritable":
                            EasyWidget.hiddenValue = this.getOut().getValue();
                            that.RenderDOMResult.updateValueVal(this.getOut().getValue());
                            break;
                        case "control:EnumWritable":
                            EasyWidget.hiddenValue = this.getOut().getValue().getOrdinal();
                            if(Object.keys(facets).length > 0 && facets.units !== null){
                                that.RenderDOMResult.updateUnits(this.getFacets1().$map.$map.units.$symbol);
                            }

                            that.RenderDOMResult.updateValueVal(this.getOut().getValue().getOrdinal(), this.getOut().getValue().getTag());
                            break;
                        case "control:NumericWritable":
                            EasyWidget.hiddenValue = this.getOut().getValue();
                            if(Object.keys(facets).length > 0 && facets.units !== null){
                                that.RenderDOMResult.updateUnits(this.getFacets1().$map.$map.units.$symbol);
                            }

                            that.RenderDOMResult.updateValueVal(this.getOut().getValue());
                            break;
                        default:
                            EasyWidget.hiddenValue = this.getOut().getValue();
                            if(Object.keys(facets).length > 0 && facets.units !== null){
                                that.RenderDOMResult.updateUnits(this.getFacets1().$map.$map.units.$symbol);
                            }
                            that.RenderDOMResult.updateValueVal(this.getOutDisplay().getValue());
                            break;
                    }
                })
                baja.Ord.make(valueOrd).get({
                    subscriber: sub
                }).then(function (val) {
                    switch (val.getType().toString()) {
                        case "control:BooleanWritable":
                            EasyWidget.hiddenValue = val.getOut().getValue();
                            that.RenderDOMResult.updateValueVal(val.getOut().getValue());
                            break;
                        case "control:EnumWritable":
                            EasyWidget.hiddenValue = val.getOut().getValue().getOrdinal();
                            that.RenderDOMResult.updateValueVal(val.getOut().getValue().getOrdinal(), val.getOut().getValue().getTag());
                            break;
                        case "control:NumericWritable":
                            EasyWidget.hiddenValue = val.getOut().getValue();
                            that.RenderDOMResult.updateValueVal(val.getOut().getValue());
                            break;
                        default:
                            EasyWidget.hiddenValue = val.getOut().getValue();
                            that.RenderDOMResult.updateValueVal(val.getOut().getValue());
                            break;
                    }
                });
            }

            if (alarmOrd != "" && alarmOrd != undefined && alarmOrd != "station:|slot:/") {
                var alarmSub = new baja.Subscriber();
                alarmSub.attach("changed", function (val) {
                    //throws exception fix
                    that.RenderDOMResult.updateAlarmVal(this.getOutDisplay());
                })
                baja.Ord.make(alarmOrd).get({
                    subscriber: alarmSub
                }).then(function (val) {
                    that.RenderDOMResult.updateAlarmVal(val.getOutDisplay());
                });
            }

            if (overrideOrd != "" && overrideOrd != undefined && overrideOrd != "station:|slot:/") {
                var overrideSub = new baja.Subscriber();
                overrideSub.attach("changed", function (val) {
                    //throws exception fix
                    that.RenderDOMResult.updateOverrideVal(this.getOutDisplay());
                })
                baja.Ord.make(overrideOrd).get({
                    subscriber: overrideSub
                }).then(function (val) {
                    that.RenderDOMResult.updateOverrideVal(val.getOutDisplay());
                });
            }

            //Render chart
            this.RenderDOMResult = easyWidgetFileRenderDOM(
                $,
                myD3,
                react,
                reactDOM,
                this.jq().height(),
                this.jq().width(),
                that.properties().getValue("data"),
                that.properties().getValue("showValue"),
                that.properties().getValue("showAlarm"),
                that.properties().getValue("showOverride"),
                that.properties().getValue("labelPosition"),
                that.properties().getValue("labelOnly"),
                element[0],easyWidgetlogBajaInfo);
        };

        EasyWidget.prototype.doLoad = function (value) {
            var that = this;
            that.RenderDOMResult.updateData(that.properties().getValue("data"), EasyWidget.hiddenValue);
        }

        //Called when ever the widget is resized
        EasyWidget.prototype.doLayout = function (value) {
            this.RenderDOMResult.updateLayout(this.jq().height(),this.jq().width());
        };

        return EasyWidget;
    }
);