"use strict";

define(["dialogs", "nmodule/honBACnetUtilities/rc/lib/react.production.min", "nmodule/honBACnetUtilities/rc/HonBacnetUtils", "lex!honBACnetUtilities", "css!nmodule/honBACnetUtilities/rc/css/counterTab"], function (dialogs, React, HonBacnetUtils, lexicons) {
  var lex = lexicons[0];
  var CounterTab = function CounterTab(props) {
    var resetStateCounter = function resetStateCounter(event) {
      event.preventDefault();
      dialogs.showYesNo({
        title: lex.get("sbc.offlineEngineering.dialog.confirm"),
        content: lex.get("BHonBacnetPointProperties.ConfirmResetCounter")
      }).yes(function () {
        props.parentCallback({
          propertyId: HonBacnetUtils.CHANGE_OF_STATE_COUNT,
          propertyValue: "0"
        });
      });
    };
    var resetRuntimeCounter = function resetRuntimeCounter(event) {
      event.preventDefault();
      dialogs.showYesNo({
        title: lex.get("sbc.offlineEngineering.dialog.confirm"),
        content: lex.get("BHonBacnetPointProperties.ConfirmResetRunTimeCounter")
      }).yes(function () {
        props.parentCallback({
          propertyId: HonBacnetUtils.ELAPSED_ACTIVE_TIME,
          propertyValue: "0"
        });
      });
    };
    return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement("fieldset", {
      className: "fieldSet-CounterTab"
    }, /*#__PURE__*/React.createElement("legend", {
      className: "legend-head"
    }, lex.get("BHonBacnetPointProperties.ChangeOfStateCounter")), /*#__PURE__*/React.createElement("div", {
      className: "row m-4"
    }, /*#__PURE__*/React.createElement("div", {
      className: "col-sm-3"
    }, /*#__PURE__*/React.createElement("label", {
      className: "form-label fw-bold"
    }, lex.get("BHonBacnetPointProperties.ChangeOfStateCount"))), /*#__PURE__*/React.createElement("div", {
      className: "col-sm-6"
    }, /*#__PURE__*/React.createElement("input", {
      type: "text",
      className: "form-control",
      name: "stateCounterValue",
      value: props.counterProps.stateCounterValue,
      readOnly: true
    })), /*#__PURE__*/React.createElement("div", {
      className: "col-sm-2"
    }, /*#__PURE__*/React.createElement("button", {
      style: {
        width: "100%",
        height: "38px",
        fontSize: "14px",
        textAlign: "center"
      },
      className: "btn btn-primary btn-sm",
      onClick: resetStateCounter
    }, lex.get("BHonBacnetPointProperties.Reset")))), /*#__PURE__*/React.createElement("div", {
      className: "row m-4"
    }, /*#__PURE__*/React.createElement("div", {
      className: "col-sm-3"
    }, /*#__PURE__*/React.createElement("label", {
      className: "form-label fw-bold"
    }, lex.get("BHonBacnetPointProperties.TimeOfStateCountReset"))), /*#__PURE__*/React.createElement("div", {
      className: "col-sm-6"
    }, /*#__PURE__*/React.createElement("input", {
      type: "text",
      className: "form-control",
      name: "stateCountResetTime",
      value: props.counterProps.stateCountResetTime,
      readOnly: true
    })), /*#__PURE__*/React.createElement("div", {
      className: "col-sm-2"
    }))), /*#__PURE__*/React.createElement("fieldset", {
      className: "fieldSet-CounterTab"
    }, /*#__PURE__*/React.createElement("legend", {
      className: "legend-head"
    }, lex.get("BHonBacnetPointProperties.RuntimeCounter")), /*#__PURE__*/React.createElement("div", {
      className: "row m-4"
    }, /*#__PURE__*/React.createElement("div", {
      className: "col-sm-3"
    }, /*#__PURE__*/React.createElement("label", {
      className: "form-label fw-bold"
    }, lex.get("BHonBacnetPointProperties.RuntimeActiveTime"))), /*#__PURE__*/React.createElement("div", {
      className: "col-sm-6"
    }, /*#__PURE__*/React.createElement("input", {
      type: "text",
      className: "form-control",
      name: "runtimeCounterValue"
      // value={HonBacnetUtils.convertSecondsToHMS(
      //   counterPropsState.runtimeCounterValue + ""
      // )}
      ,
      value: props.counterProps.runtimeCounterValue,
      readOnly: true
    })), /*#__PURE__*/React.createElement("div", {
      className: "col-sm-2"
    }, /*#__PURE__*/React.createElement("button", {
      style: {
        width: "100%",
        height: "38px",
        fontSize: "14px",
        textAlign: "center"
      },
      className: "btn btn-primary btn-sm",
      onClick: resetRuntimeCounter
    }, lex.get("BHonBacnetPointProperties.Reset")))), /*#__PURE__*/React.createElement("div", {
      className: "row m-4"
    }, /*#__PURE__*/React.createElement("div", {
      className: "col-sm-3"
    }, /*#__PURE__*/React.createElement("label", {
      className: "form-label fw-bold"
    }, lex.get("BHonBacnetPointProperties.TimeOfLastActiveTimeReset"))), /*#__PURE__*/React.createElement("div", {
      className: "col-sm-6"
    }, /*#__PURE__*/React.createElement("input", {
      type: "text",
      className: "form-control",
      name: "runtimeLastResetTime",
      value: props.counterProps.runtimeLastResetTime,
      readOnly: true
    })), /*#__PURE__*/React.createElement("div", {
      className: "col-sm-2"
    }))));
  };
  return CounterTab;
});
