"use strict";

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }
function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }
function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }
function _iterableToArrayLimit(arr, i) { var _i = null == arr ? null : "undefined" != typeof Symbol && arr[Symbol.iterator] || arr["@@iterator"]; if (null != _i) { var _s, _e, _x, _r, _arr = [], _n = !0, _d = !1; try { if (_x = (_i = _i.call(arr)).next, 0 === i) { if (Object(_i) !== _i) return; _n = !1; } else for (; !(_n = (_s = _x.call(_i)).done) && (_arr.push(_s.value), _arr.length !== i); _n = !0) { ; } } catch (err) { _d = !0, _e = err; } finally { try { if (!_n && null != _i["return"] && (_r = _i["return"](), Object(_r) !== _r)) return; } finally { if (_d) throw _e; } } return _arr; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
define(["nmodule/honBACnetUtilities/rc/lib/react.production.min", "nmodule/honBACnetUtilities/rc/HonBacnetUtils", "lex!honBACnetUtilities", "css!nmodule/honBACnetUtilities/rc/css/commandpriorities"], function (React, HonBacnetUtils, lexicons) {
  var lex = lexicons[0];
  var getArrayChunks = function getArrayChunks(array, chunkSize) {
    var R = [];
    for (var i = 0; i < array.length; i += chunkSize) {
      R.push(array.slice(i, i + chunkSize));
    }
    return R;
  };
  var getCommandPrioritiesList = function getCommandPrioritiesList(commandPriority, relinquishDefault) {
    return [{
      priorityId: 1,
      name: lex.get("PriorityLevel.1.ManualLifeSafety"),
      value: commandPriority.V_1
    }, {
      priorityId: 2,
      name: lex.get("PriorityLevel.2.AutomaticLifeSafety"),
      value: commandPriority.V_2
    }, {
      priorityId: 3,
      name: "-",
      value: commandPriority.V_3
    }, {
      priorityId: 4,
      name: "-",
      value: commandPriority.V_4
    }, {
      priorityId: 5,
      name: lex.get("PriorityLevel.5.CriticalEquipmentControl"),
      value: commandPriority.V_5
    }, {
      priorityId: 6,
      name: lex.get("PriorityLevel.6.MinimumOnOff"),
      value: commandPriority.V_6
    }, {
      priorityId: 7,
      name: "-",
      value: commandPriority.V_7
    }, {
      priorityId: 8,
      name: lex.get("PriorityLevel.8.ManualOperator"),
      value: commandPriority.V_8
    }, {
      priorityId: 9,
      name: "-",
      value: commandPriority.V_9
    }, {
      priorityId: 10,
      name: "-",
      value: commandPriority.V_10
    }, {
      priorityId: 11,
      name: "-",
      value: commandPriority.V_11
    }, {
      priorityId: 12,
      name: "-",
      value: commandPriority.V_12
    }, {
      priorityId: 13,
      name: "-",
      value: commandPriority.V_13
    }, {
      priorityId: 14,
      name: "-",
      value: commandPriority.V_14
    }, {
      priorityId: 15,
      name: lex.get("PriorityLevel.15.ControlProgram"),
      value: commandPriority.V_15
    }, {
      priorityId: 16,
      name: lex.get("PriorityLevel.16.RelinquishDefault"),
      value: relinquishDefault
    }];
  };
  var CommandPriorities = function CommandPriorities(props) {
    var _React$useState = React.useState([]),
      _React$useState2 = _slicedToArray(_React$useState, 2),
      commandPriorityState = _React$useState2[0],
      setCommandPriorityState = _React$useState2[1];
    React.useEffect(function () {
      if (props.commandPriorityProps || props.relinquishDefaultProps) {
        setCommandPriorityState(getCommandPrioritiesList(props.commandPriorityProps, props.relinquishDefaultProps));
      }
    }, [props.commandPriorityProps, props.relinquishDefaultProps]);
    var handleValueChange = function handleValueChange(e) {
      var mutateCommandPriority = _toConsumableArray(commandPriorityState);
      var index = mutateCommandPriority.findIndex(function (i) {
        return i.priorityId == e.target.id;
      });
      if (index >= 0) {
        mutateCommandPriority[index].value = e.target.value;
        setCommandPriorityState(mutateCommandPriority);
        var jsonProperty = {
          propertyId: HonBacnetUtils.RELINQUISH_DEFAULT,
          propertyValue: {
            value: e.target.value
          },
          isNumeric: props.objectType === "binaryValue" || props.objectType === "binaryOutput" ? false : true,
          isBinary: props.objectType === "binaryValue" || props.objectType === "binaryOutput" ? true : false
        };
        props.parentCallback(jsonProperty);
      }
    };
    return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement("div", {
      className: "row"
    }, getArrayChunks(commandPriorityState, 8).map(function (commandPriorityList) {
      return /*#__PURE__*/React.createElement("div", {
        className: "column"
      }, /*#__PURE__*/React.createElement("table", {
        className: "command-priorities-table small-first-col"
      }, /*#__PURE__*/React.createElement("thead", null, /*#__PURE__*/React.createElement("tr", null, /*#__PURE__*/React.createElement("th", null), /*#__PURE__*/React.createElement("th", null, lex.get("BHonBacnetPointProperties.CommandPriorities.PriorityLevel")), /*#__PURE__*/React.createElement("th", null, lex.get("BHonBacnetPointProperties.CommandPriorities.Value")))), /*#__PURE__*/React.createElement("tbody", {
        className: "body-half-screen"
      }, commandPriorityList.map(function (item) {
        return /*#__PURE__*/React.createElement("tr", null, /*#__PURE__*/React.createElement("td", null, item.priorityId), /*#__PURE__*/React.createElement("td", null, item.name), /*#__PURE__*/React.createElement("td", null, item.priorityId == 16 && (props.objectType === "binaryValue" || props.objectType === "binaryOutput") ? /*#__PURE__*/React.createElement("select", {
          id: item.priorityId,
          onChange: handleValueChange,
          value: item.value
        }, props.alarmValues.map(function (item) {
          return /*#__PURE__*/React.createElement("option", {
            value: item.value
          }, item.text);
        })) : /*#__PURE__*/React.createElement("input", {
          type: "text",
          value: item.value,
          id: item.priorityId,
          fieldName: item.name,
          onChange: handleValueChange,
          readOnly: item.priorityId == 16 ? false : true
        })));
      }))));
    })));
  };
  return CommandPriorities;
});
