define(['lex!easyBinding'], function (lexicons) {
    return function renderDOM($, baja, slotPath, myD3, React, ReactDOM, _, html2canvas, EbUtils, EasyBindingEdit,
                              height, width, element, logs, sendLogBajaInfo, dragDropUtils, PopupDialog, PointChooser) {
        const lex = lexicons[0];

        const Popup = React.createClass({
            render() {
                return (
                    <div style={{
                        position: 'fixed',
                        width: '100%',
                        height: '100%',
                        top: 0,
                        left: 0,
                        right: 0,
                        bottom: 0,
                        margin: 'auto',
                        backgroundColor: 'rgba(0, 0, 0, 0.5)',
                        zIndex: '999999'
                    }}
                    >
                        <div style={{
                            position: 'absolute',
                            left: 'calc(100% - 55%)',
                            right: 'calc(100% - 75%)',
                            top: 'calc(100% - 65%)',
                            bottom: 'calc(100% - 75%)',
                            margin: 'auto',
                            background: 'transparent',
                            height: '25%',
                        }}>
                            <div className="js-dialog ux-root ux-fg ux-shadow ux-border">
                                <div className="js-dialog-header ux-bg">{lex.get("eb.easyBinding.confirmation")}</div>
                                <div className="js-dialog-content-wrapper">
                                    <div className="js-dialog-content">{lex.get("eb.easyBinding.continuingWillReset")}
                                    </div>
                                </div>
                                <ul className="js-dialog-button-content ux-fg">
                                    <li>
                                        <button type="button" className="ux-btn js-dialog-button js-dialog-button-yes"
                                                onClick={() => this.props.selectionMade("Continue")}>{lex.get("eb.easyBinding.continue")}
                                        </button>
                                    </li>
                                    <li>
                                        <button type="button"
                                                className="ux-btn js-dialog-button js-dialog-button-cancel"
                                                onClick={() => this.props.selectionMade("Cancel")}> {lex.get("eb.easyBinding.cancel")}
                                        </button>
                                    </li>
                                </ul>
                            </div>
                        </div>
                    </div>
                );
            }
        });

        /**
         This component created to show Easy Binding - Point Browser dialog.
         **/


        const EditView = React.createClass({

            getDefaultProps: function () {
                return {
                    widgets: [],
                    pxSize: {h: "0", w: "0"},
                    selectedChanged: () => {
                        /**
                         *
                         */
                    },
                    addLabelWidget: () => {
                        /**
                         *
                         */
                    },
                    lastWidgetIndex: () => {
                        /**
                         *
                         */
                    },
                    pxOrd: "",
                    backgroundCanvas: null,
                    addedWidgets: [],
                    HighlightedSelectedToolbarAction: () => {
                        /**
                         *
                         */
                    },
                }
            },

            getInitialState: function () {
                return {
                    widgets: this.props.widgets,
                    pxSize: this.props.pxSize,
                    selectedChanged: this.props.selectedChanged,
                    addLabelWidget: this.props.addLabelWidget,
                    lastWidgetIndex: this.props.lastWidgetIndex,
                    pxOrd: this.props.pxOrd,
                    backgroundCanvas: this.props.backgroundCanvas,
                    addedWidgets: [],
                    HighlightedSelectedToolbarAction: this.props.HighlightedSelectedToolbarAction,
                    setLabelPosition: this.props.setLabelPosition,
                }
            },

            componentWillReceiveProps: function (nextProps) {
                this.setState({
                    widgets: nextProps.widgets,
                    pxSize: nextProps.pxSize,
                    selectedChanged: nextProps.selectedChanged,
                    addLabelWidget: nextProps.addLabelWidget,
                    pxOrd: nextProps.pxOrd,
                    backgroundCanvas: nextProps.backgroundCanvas,
                    lastWidgetIndex: nextProps.lastWidgetIndex,
                    HighlightedSelectedToolbarAction: nextProps.HighlightedSelectedToolbarAction,
                    setLabelPosition: nextProps.setLabelPosition,
                });
            },

            componentDidUpdate(prevProps, prevState) {
                if (this.state.setLabelPosition !== undefined && this.state.setLabelPosition === true) {
                    this.state.HighlightedSelectedToolbarAction(this.props.labelPos);
                }
            },

            calculateAspectRatio: function () {
                const w = parseInt(this.state.pxSize.w,10), h = parseInt(this.state.pxSize.h, 10);
                const gdc = this.GCD(w, h);
                return (w / gdc + ":" + h / gdc)
            },

            GCD: function (a, b) {
                return b === 0 ? Math.abs(a) : this.GCD(b, a % b);
            },

            scrolled: function (value) {
                /**
                 *
                 */
            },

            dragEnter: function (ev) {
                ev.preventDefault();
            },

            dragOver: function (ev) {
                ev.preventDefault();
            },

            onDrop: function (event) {
                if (event.target.id === "editviewDrag") {
                    const _This = this;
                    const data = event.dataTransfer.getData("ord");
                    const position = $('#editcontainer').offset();
                    event.preventDefault();
                    const move = event.dataTransfer.getData("move");
                    const label = event.dataTransfer.getData("label");
                    const dropped = event.dataTransfer.getData("dropped");

                    const y = (event.clientX - position.left);
                    const x = (event.clientY - position.top);
                    if (!event.target.id.startsWith("EasyBindingEdit") && data !== null && data !== undefined && data !== "") {
                        if (dropped === "true") {
                            return;
                        }
                        // if this is a widget that has just been moved
                        if (move === "true" && label === "true") {
                            const moveIndex = event.dataTransfer.getData("moveIndex");

                            const widget = {};
                            widget.x = x;
                            widget.y = y;
                            widget.index = moveIndex;

                            this.state.addLabelWidget(moveIndex, widget, true)

                        } else {
                            if (label !== "false") {

                            const customWidgets = this.state.addedWidgets;
                            const labelwidget = {};
                            labelwidget.x = x;
                            labelwidget.y = y;
                            labelwidget.ord = data;
                            labelwidget.index = customWidgets.length + 1;

                            customWidgets.push(labelwidget);

                            _This.setState({
                                addedWidgets: customWidgets
                            }, () => {
                                _This.state.addLabelWidget(labelwidget.index, labelwidget, false);
                            });
                        }
                    }
                    } else {
                        if (dropped === "true") {
                            return;
                        }
                        const p1 = dragDropUtils.fromClipboard(event.dataTransfer).then(function (envelope) {
                            return envelope.toJson().then(function (json) {
                                if (json !== undefined && json.length > 0) {
                                    const firstObj = json[0];
                                    if (firstObj.typeSpec.includes("Boolean") || firstObj.typeSpec.includes("Numeric") || firstObj.typeSpec.includes("Enum")) {
                                        let data = firstObj.ord;
                                        data = data.substring(data.indexOf("|slot:/") + 7);
                                        return Promise.resolve(data);
                                    }
                                }
                            });
                        });
                        p1.then(function (val) {
                            const pointOrd = val;
                            if (pointOrd !== undefined && pointOrd !== "") {
                                _This.addLabelCustomWidget(pointOrd, x, y, _This);
                            }
                        });


                    }
                }
            },
            addLabelCustomWidget: function (data, x, y, _Obj) {
                const customWidgets = this.state.addedWidgets;
                const labelwidget = {};
                labelwidget.x = x;
                labelwidget.y = y;
                labelwidget.ord = data;
                labelwidget.index = customWidgets.length + 1;

                customWidgets.push(labelwidget);

                _Obj.setState({
                    addedWidgets: customWidgets
                }, () => {
                    _Obj.state.addLabelWidget(labelwidget.index, labelwidget, false);
                });

            },
            onCustomWidgetMove: function (index, x, y) {
                const customWidgets = this.state.addedWidgets;
                customWidgets.forEach((widget => {
                    if (widget.index === index) {
                        widget.x = x;
                        widget.y = y;
                    }
                }));

                this.setState({
                    addedWidgets: customWidgets
                });
            },
            onCurrentWidgetIndex: function (index) {
                this.state.lastWidgetIndex(index);
            },
            render: function () {
                const rootThis = this;

                return (
                    <div id="editview" style={{height: '100%', width: '100%', overflow: 'auto'}}
                         onScroll={this.scrolled}>
                        <div id="editviewDrag"
                             style={{height: '100%', width: '100%', overflow: 'auto', minHeight: '100px'}}
                             onDragEnter={this.dragEnter}
                             onDragOver={this.dragEnter}
                             onDrop={this.onDrop}>
                            <div id="editcontainer"
                                 style={{
                                     background: this.state.backgroundCanvas === null ? "none" : 'url(' + this.state.backgroundCanvas.toDataURL('image/png') + ')',
                                     position: 'relative'
                                 }}>
                                {rootThis.state.widgets && rootThis.state.widgets.map((widget, index) => (
                                    <EasyBindingEdit ref={(node) => {
                                        this[`EasyBindingEdit${widget.index}`] = node;
                                    }}
                                                     index={widget.index}
                                                     width={widget.width}
                                                     height={widget.height}
                                                     x={widget.x}
                                                     y={widget.y}
                                                     valueOrd={widget.value}
                                                     alarmOrd={widget.alarm}
                                                     overrideOrd={widget.override}
                                                     showValue={widget.showValue}
                                                     showAlarm={widget.showalarm}
                                                     showOverride={widget.showoverride}
                                                     labelPos={widget.labelpos}
                                                     data={widget.data}
                                                     selected={this.state.selectedChanged}
                                                     highlighted={this.props.init}
                                                     widgetSelected={this.props.widgetSelected}
                                                     labelOnly={widget.labelonly}
                                                     widgetName={widget.widgetName}
                                                     widgetPath={widget.widgetPath}
                                                     labelMoved={rootThis.onCustomWidgetMove}
                                                     currentWidgetIndex={rootThis.onCurrentWidgetIndex}
                                    />
                                ))}
                            </div>
                        </div>
                    </div>
                );
            },


        });

        const BindingToolbar = React.createClass({

            getDefaultProps: function () {
                return {
                    id: -1,
                    labelPos: "none",
                    showValue: true,
                    displayOverride: true,
                    showAlarm: true,
                    saveFile: () => {
                    },
                    toggleLabel: () => {
                    },
                    toggleAlarm: () => {
                    },
                    toggleOverride: () => {
                    },
                    labelLeft: () => {
                    },
                    labelRight: () => {
                    },
                    labelTop: () => {
                    },
                    labelBottom: () => {
                    },
                    clearBinding: () => {
                    },
                    revert: () => {
                    },
                    undo: () => {
                    },
                    valueOrd: "",
                    overrideOrd: "",
                    alarmOrd: "",
                    allOrd: "",
                    labelOnly: false,
                    undoIndex: [],
                    HighlightedSelectedToolbarAction: () => {
                        /**
                         *
                         */
                    },
                    showFlag: false,
                    backgroundCanvas: null,
                    widgets: [],
                    pxSize: {h: "0", w: "0"},
                    pxOrd: "",
                    addBinding: () => {
                        /**
                         *
                         */
                    },
                    isDirty: false,
                    enableUndo: false,
                }
            },

            getInitialState: function () {
                return {
                    id: this.props.id,
                    labelPos: this.props.labelPos,
                    showValue: this.props.showValue,
                    displayOverride: this.props.displayOverride,
                    showAlarm: this.props.showAlarm,
                    saveFile: this.props.save,
                    toggleLabel: this.props.toggleLabel,
                    toggleAlarm: this.props.toggleAlarm,
                    toggleOverride: this.props.toggleOverride,
                    labelLeft: this.props.labelLeft,
                    labelRight: this.props.labelRight,
                    labelTop: this.props.labelTop,
                    labelBottom: this.props.labelBottom,
                    clearBinding: this.props.clearBinding,
                    revert: this.props.revert,
                    undo: this.props.undo,
                    valueOrd: this.props.valueOrd,
                    overrideOrd: this.props.overrideOrd,
                    alarmOrd: this.props.alarmOrd,
                    labelOnly: this.props.labelOnly,
                    undoIndex: this.props.undoIndex,
                    allOrd: this.props.allOrd,
                    HighlightedSelectedToolbarAction: this.props.HighlightedSelectedToolbarAction,
                    showFlag: this.props.showFlag,
                    backgroundCanvas: this.props.backgroundCanvas,
                    widgets: this.props.widgets,
                    pxSize: this.props.pxSize,
                    pxOrd: this.props.pxOrd,
                    addBinding: this.props.addBinding,
                    isDirty: this.props.isDirty,
                    enableUndo: this.props.enableUndo,
                    selectedWidgetName: this.props.selectedWidgetName,
                    selectedWidgetPath: this.props.selectedWidgetPath,
                }
            },

            componentWillReceiveProps: function (nextProps) {

                this.setState({
                    id: nextProps.id,
                    labelPos: nextProps.labelPos,
                    showValue: nextProps.showValue,
                    displayOverride: nextProps.displayOverride,
                    showAlarm: nextProps.showAlarm,
                    saveFile: nextProps.save,
                    toggleLabel: nextProps.toggleLabel,
                    toggleAlarm: nextProps.toggleAlarm,
                    toggleOverride: nextProps.toggleOverride,
                    labelLeft: nextProps.labelLeft,
                    labelRight: nextProps.labelRight,
                    labelTop: nextProps.labelTop,
                    labelBottom: nextProps.labelBottom,
                    clearBinding: nextProps.clearBinding,
                    revert: nextProps.revert,
                    undo: nextProps.undo,
                    valueOrd: nextProps.valueOrd,
                    overrideOrd: nextProps.overrideOrd,
                    alarmOrd: nextProps.alarmOrd,
                    labelOnly: nextProps.labelOnly,
                    undoIndex: nextProps.undoIndex,
                    allOrd: nextProps.allOrd,
                    HighlightedSelectedToolbarAction: nextProps.HighlightedSelectedToolbarAction,
                    showFlag: nextProps.showFlag,
                    backgroundCanvas: nextProps.backgroundCanvas,
                    widget: nextProps.widget,
                    pxSize: nextProps.pxSize,
                    pxOrd: nextProps.pxOrd,
                    addBinding: nextProps.addBinding,
                    isDirty: nextProps.isDirty,
                    enableUndo: nextProps.enableUndo,
                    selectedWidgetName: nextProps.selectedWidgetName,
                    selectedWidgetPath: nextProps.selectedWidgetPath,
                });

                return false;
            },

            bindingViewChanged: function () {

                var x = document.getElementById("frame");
                var y = (x.contentWindow || x.contentDocument);
                if (y.document) y = y.document;

                var widgets = y.getElementsByClassName("EasyBindingWidget active");
                for (var i = 0; i < widgets.length; i++) {
                    widgets[i].style.border = "1px solid #00FF21";
                }
            },

            componentDidUpdate: function () {
                //this.state.saveFile();
            },

            saveAll: function () {
                this.state.saveFile();
            },

            toggleLabel: function () {
                this.state.toggleLabel(this.state.id);

            },

            labelLeft: function () {
                this.state.labelLeft(this.state.id);
                this.state.HighlightedSelectedToolbarAction("left");
            },

            labelRight: function () {
                this.state.labelRight(this.state.id);
                this.state.HighlightedSelectedToolbarAction("right");
            },

            labelTop: function () {
                this.state.labelTop(this.state.id);
                this.state.HighlightedSelectedToolbarAction("top");
            },

            labelBottom: function () {
                this.state.labelBottom(this.state.id);
                this.state.HighlightedSelectedToolbarAction("bottom");
            },

            toggleAlarm: function () {
                this.state.toggleAlarm(this.state.id);
            },

            toggleOverride: function () {
                this.state.toggleOverride(this.state.id);
            },

            clearBinding: function (type) {
                this.state.clearBinding(this.state.id, type);
            },

            undoPage: function () {
                var _that = this;
                if (this.state.undoIndex.length > 0) {
                    var idx = this.state.undoIndex.pop();
                    this.state.undo(idx);
                    logs("Undo clicked by user for widget index: " + idx);
                }
                if (this.state.undoIndex.length == 0) {
                    setTimeout(function () {
                        _that.state.undo(-1);
                    }, 100);

                }
            },
            revertPage: function () {
                this.state.revert();
            },

            getAllOrd: function () {
                if ((this.state.valueOrd === "" || this.state.valueOrd == "null") && (this.state.alarmOrd === "" || this.state.alarmOrd == "null") && (this.state.overrideOrd === "" || this.state.overrideOrd == "null")) {
                    this.state.allOrd = "null";
                } else {
                    this.state.allOrd = "All";
                }

            },

            addBinding: function (type, ord) {
                this.state.addBinding(this.state.id, type, ord);
            },

            toolbarHeader : function () {
                const header = lex.get("eb.easyBinding.properties");
                if (this.state.selectedWidgetName !== "" && this.state.selectedWidgetPath !== "") {
                    return <span>{header} - {this.state.selectedWidgetName} - {this.state.selectedWidgetPath}</span>;
                } else if (this.state.selectedWidgetName !== "") {
                    return <span>{header} - {this.state.selectedWidgetName}</span>;
                }else {
                    return <span>{header}</span>;
                }
            },

            render: function () {
                this.getAllOrd();
                let toolbarHeaderText = this.toolbarHeader();
                return (
                    <div style={{flexShrink: 1, display: 'flex', flexDirection: 'column'}}>
                        <div>
                            <div style={{display: 'flex', flexFlow: 'row nowrap', justifyContent: 'left'}}>
                                <div style={{
                                    background: '#F9F9F9',
                                    width: '100%',
                                    marginLeft: '10px',
                                    marginRight: '10px',
                                    borderBottom: '2px solid #EBEBEB'
                                }}>
                                    <div style={{
                                        display: 'table',
                                        background: 'white',
                                        border: '1px solid #DCDCDC',
                                        boxSizing: 'border-box',
                                        borderBottom: '3px solid #96B7E8',
                                        borderRight: '2px solid #EBEBEB',
                                        paddingLeft: '10px',
                                        paddingRight: '15px'
                                    }}>
                                        <div style={{display: 'table-cell', verticalAlign: 'middle'}}>
                                            {toolbarHeaderText}
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div style={{
                            width: '100%',
                            display: 'flex',
                            flexFlow: 'row nowrap',
                            minWidth: '1200px',
                            paddingLeft: '10px'
                        }}>
                            <div style={{
                                width: '5%',
                                borderLeft: '3px solid #DCDCDC',
                                borderTop: '3px solid #DCDCDC',
                                borderBottom: '3px solid #DCDCDC',
                                padding: '2px'
                            }}>
                                <div style={{
                                    height: '100%',
                                    width: '100%',
                                    display: 'flex',
                                    flexFlow: 'row nowrap',
                                    justifyContent: 'space-around',
                                    flexDirection: 'column'
                                }}>
                                    <ActionButton undoPage={this.undoPage} revertPage={this.revertPage}
                                                  isDirty={this.state.isDirty} enableUndo={this.state.enableUndo}/>
                                </div>
                            </div>
                            <div style={{width: '60%', border: '3px solid #DCDCDC'}}>
                                <div style={{height: '100%', display: 'flex'}}>
                                    <div style={{width: '10%', maxWidth: '60px', minWidth: '50px'}}>
                                        <Toolbar labelPos={this.state.labelPos} showValue={this.state.showValue}
                                                 HighlightedSelectedToolbarAction={this.state.HighlightedSelectedToolbarAction}
                                                 labelText="All" bindingButton={true} addBinding={this.addBinding}
                                                 clearBinding={this.clearBinding} useImage={false}
                                                 pointName={this.state.allOrd}
                                                 selected={(this.state.valueOrd === "" && this.state.alarmOrd === "" && this.state.overrideOrd === "") || (this.state.valueOrd == "null" && this.state.alarmOrd == "null" && this.state.overrideOrd == "null") ? false : true}
                                                 highlightOnHover={false}/>
                                    </div>
                                    <div style={{width: '30%', borderLeft: '10px solid #000000'}}>
                                        <Toolbar labelPos={this.state.labelPos} showValue={this.state.showValue}
                                                 HighlightedSelectedToolbarAction={this.state.HighlightedSelectedToolbarAction}
                                                 labelText="Value" bindingButton={true} labelLeft={this.labelLeft}
                                                 labelRight={this.labelRight} labelTop={this.labelTop}
                                                 labelBottom={this.labelBottom} toggleLabel={this.toggleLabel}
                                                 addBinding={this.addBinding} clearBinding={this.clearBinding}
                                                 useImage={false} colour='#000000' pointName={this.state.valueOrd}
                                                 selected={this.state.valueOrd === "" || this.state.valueOrd == "null" ? false : true}
                                                 highlightOnHover={false}/>
                                    </div>
                                    <div style={{width: '30%', borderLeft: '10px solid #D80000'}}>
                                        <Toolbar labelPos={this.state.labelPos} showValue={this.state.showValue}
                                                 HighlightedSelectedToolbarAction={this.state.HighlightedSelectedToolbarAction}
                                                 labelText="Alarm" bindingButton={true} labelLeft={this.labelLeft}
                                                 labelRight={this.labelRight} labelTop={this.labelTop}
                                                 labelBottom={this.labelBottom} toggleLabel={this.toggleLabel}
                                                 addBinding={this.addBinding} clearBinding={this.clearBinding}
                                                 useImage={false} colour='#D80000' pointName={this.state.alarmOrd}
                                                 selected={this.state.alarmOrd === "" || this.state.alarmOrd == "null" ? false : true}
                                                 highlightOnHover={false}/>
                                    </div>
                                    <div style={{width: '30%', borderLeft: '10px solid #BF96CB'}}>
                                        <Toolbar labelPos={this.state.labelPos} showValue={this.state.showValue}
                                                 HighlightedSelectedToolbarAction={this.state.HighlightedSelectedToolbarAction}
                                                 labelText="Override" bindingButton={true} labelLeft={this.labelLeft}
                                                 labelRight={this.labelRight} labelTop={this.labelTop}
                                                 labelBottom={this.labelBottom} toggleLabel={this.toggleLabel}
                                                 addBinding={this.addBinding} clearBinding={this.clearBinding}
                                                 useImage={false} colour='#BF96CB' pointName={this.state.overrideOrd}
                                                 selected={this.state.overrideOrd === "" || this.state.overrideOrd == "null" ? false : true}
                                                 showRightSplitter={this.state.labelOnly === "true" ? false : true}
                                                 highlightOnHover={false}/>
                                    </div>
                                </div>
                            </div>
                            <div style={{
                                width: '35%',
                                justifyContent: 'right',
                                backgroundImage: 'url("/ord?module://easyBinding/res/images/gradient1-ico.png")'
                            }}>
                            </div>
                        </div>
                    </div>
                );
            }
        });

        /**
         This component created to bind image to toolbar button.
         **/
        var ToolButton = React.createClass({

            getDefaultProps: function () {
                return {
                    labelImage: "Empty",
                }
            },
            getInitialState: function () {
                return {
                    labelImage: this.props.labelImage,
                }
            },
            componentWillReceiveProps: function (nextProps) {
                this.setState({});
            },

            render: function () {
                return (
                    <div>
                        <div><img style={{
                            width: this.props.imageSizeChange ? '14px' : '20.8px',
                            objectFit: 'scale-down',
                            align: 'middle'
                        }} src={this.props.labelImage}/></div>
                    </div>
                );
            }
        });

        /**
         This component created for undo and revert toolbar buttons.
         **/
        const ActionButton = React.createClass({

            getDefaultProps: function () {
                return {
                    labelImage: "Empty",
                    revert: () => {
                        /**
                         *
                         */
                    },
                    undo: () => {
                        /**
                         *
                         */
                    },
                    undoPage: () => {
                        /**
                         *
                         */
                    },
                    revertPage: () => {
                        /**
                         *
                         */
                    },
                    showPopup: false,
                    isDirty: false,
                    enableUndo: false,
                }
            },
            getInitialState: function () {
                return {
                    labelImage: this.props.labelImage,
                    revert: this.props.revert,
                    undo: this.props.undo,
                    undoPage: this.props.undoPage,
                    revertPage: this.props.revertPage,
                    showPopup: this.props.showPopup,
                    isDirty: this.props.isDirty,
                    enableUndo: this.props.enableUndo
                }
            },
            componentWillReceiveProps: function (nextProps) {
                this.setState({
                    revert: nextProps.revert,
                    undo: nextProps.undo,
                    undoPage: nextProps.undoPage,
                    revertPage: nextProps.revertPage,
                    isDirty: nextProps.isDirty,
                    enableUndo: nextProps.enableUndo
                });
            },
            revertPage: function () {
                this.props.revertPage();
            },
            undoPage: function (e) {
                this.props.undoPage();
            },

            render: function () {
                let enableIconsClass = "";
                if (this.state.enableUndo) {
                    enableIconsClass = "btn"
                } else {
                    enableIconsClass = "btn disabled"
                }
                return (
                    <div style={{display: 'flex', flexDirection: 'column', justifyContent: 'center'}}>
                        <button style={{marginBottom: '1px'}} count={2} className={enableIconsClass}
                                onClick={this.undoPage} type="button">{lex.get("eb.easyBinding.undo")}</button>
                        <button style={{marginTop: '1px'}} count={2} className={enableIconsClass}
                                onClick={this.revertPage} type="button">{lex.get("eb.easyBinding.revert")}</button>
                        {
                            this.state.showPopup ?
                                <Popup
                                    selectionMade={this.revertPage}
                                /> : null
                        }
                    </div>
                );
            }
        });

        /**
         This component created for toolbar properties.
         **/
        const Toolbar = React.createClass({

            getDefaultProps: function () {
                return {
                    labelText: "Empty",
                    labelImage: "Empty",
                    labelSelectedImage: "None",
                    selected: false,
                    clicked: () => {
                        /**
                         *
                         */
                    },
                    showRightSplitter: false,
                    count: 10,
                    useImage: false,
                    colour: 'blue',
                    bindingButton: false,
                    pointName: 'Error',
                    clearBinding: () => {
                        /**
                         *
                         */
                    },
                    labelLeft: () => {
                        /**
                         *
                         */
                    },
                    labelRight: () => {
                        /**
                         *
                         */
                    },
                    labelTop: () => {
                        /**
                         *
                         */
                    },
                    labelBottom: () => {
                        /**
                         *
                         */
                    },
                    showValue: true,
                    toggleLabel: () => {
                        /**
                         *
                         */
                    },
                    highlightOnHover: true,
                    HighlightedSelectedToolbarAction: () => {
                        /**
                         *
                         */
                    },
                    addBinding: () => {
                        /**
                         *
                         */
                    },
                    imageSizeChange: false,


                }
            },
            getInitialState: function () {
                return {
                    labelText: this.props.labelText,
                    labelImage: this.props.labelImage,
                    labelSelectedImage: this.props.labelSelectedImage,
                    selected: this.props.selected,
                    clicked: this.props.clicked,
                    showRightSplitter: this.props.showRightSplitter,
                    count: this.props.count,
                    useImage: this.props.useImage,
                    colour: this.props.colour,
                    bindingButton: this.props.bindingButton,
                    isMouseInside: false,
                    clearBinding: this.props.clearBinding,
                    labelLeft: this.props.labelLeft,
                    labelRight: this.props.labelRight,
                    labelTop: this.props.labelTop,
                    labelBottom: this.props.labelBottom,
                    showValue: this.props.showValue,
                    toggleLabel: this.props.toggleLabel,
                    highlightOnHover: this.props.highlightOnHover,
                    labelPos: this.props.labelPos,
                    HighlightedSelectedToolbarAction: this.props.HighlightedSelectedToolbarAction,
                    addBinding: this.props.addBinding,
                    imageSizeChange: this.props.imageSizeChange,

                }
            },

            componentDidMount: function () {
                this.props.HighlightedSelectedToolbarAction(this.state.labelPos);
            },

            componentWillReceiveProps: function (nextProps) {
                this.setState({
                    HighlightedSelectedToolbarAction: nextProps.HighlightedSelectedToolbarAction,
                    labelPos: nextProps.labelPos,
                    showValue: nextProps.showValue,
                });
            },
            buttonClicked: function () {
                this.setState({
                    showPopup: !this.state.showPopup
                });
            },
            popupDialogCloseHandler: function (returnValue) {
                const _This = this;
                if (returnValue.selectedPointOrd === "") {
                    return;
                } else {
                    if (returnValue.buttonType === "Ok") {
                        _This.state.addBinding([_This.props.labelText], returnValue.selectedPointOrd);
                    }
                    this.setState({showPopup: false});
                }
            },
            mouseEnter: function () {
                this.setState({isMouseInside: true});
            },
            mouseLeave: function () {
                this.setState({isMouseInside: false});
            },

            dragEnter: function (ev) {
                ev.preventDefault();
            },

            dragOver: function (ev) {
                ev.preventDefault();
            },

            onDrop: function (event) {
                const _This = this;
                event.preventDefault();
                event.persist();
                const p1 = dragDropUtils.fromClipboard(event.dataTransfer).then(function (envelope) {
                    return envelope.toJson().then(function (json) {
                        if (json !== undefined && json.length > 0) {
                            const firstObj = json[0];
                            if (firstObj.typeSpec.includes("Boolean") || firstObj.typeSpec.includes("Numeric") || firstObj.typeSpec.includes("Enum")) {
                                let data = firstObj.ord;
                                data = data.substring(data.indexOf("|slot:/") + 7);
                                return Promise.resolve(data);
                            }
                        }
                    });
                });
                p1.then(function (val) {
                    const pointOrd = val;
                    if (pointOrd !== undefined && pointOrd !== "") {
                        _This.state.addBinding([_This.props.labelText], pointOrd);
                    }
                });
            },

            render: function () {
                return (
                    <div onDragEnter={this.dragEnter} onDragOver={this.dragEnter} onDrop={this.onDrop}>
                        <div onMouseEnter={this.mouseEnter} onMouseLeave={this.mouseLeave}>
                            <div className="item-header" style={{width: '98%', display: 'flex', padding: '5px'}}>
                                <div style={{
                                    width: '50%',
                                    textAlign: 'center',
                                    display: this.state.useImage === true ? 'block' : 'flex',
                                    flexDirection: 'row',
                                    fontWeight: 'bold'
                                }}>
                                    {this.state.bindingButton === true ?
                                        <div>
                                            {this.props.labelText}</div> :
                                        this.state.useImage === true ?
                                            <img style={{width: '23px', objectFit: 'scale-down', align: 'middle'}}
                                                 src={this.props.labelImage}/>
                                            : <CanvasComponent color={this.state.colour} width={30}
                                                               filled={false}/>}</div>
                                {this.props.labelText !== "All" ?
                                    <div style={{width: '40%', marginTop:'3px'}}>
                                        {(this.props.pointName !== "" && this.props.pointName !== "null") && this.props.labelText !== "All" ?
                                            <div className="action-icons" style={{
                                                width: '100%',
                                                display: 'flex',
                                                flexDirection: 'row',
                                                justifyContent: 'right'
                                            }}>
                                                <div style={{paddingRight: '1px'}} id="labelLeft" className="btn"
                                                     onClick={event => this.state.labelLeft()}>
                                                    <div style={{opacity: "0.5"}}
                                                         className="btn labelLeft">{this.state.labelOnly === "true" ? null :
                                                        <ToolButton labelText={lex.get("eb.easyBinding.left")}
                                                                    useImage={true}
                                                                    selected={this.state.labelPos === "left" ? true : false}
                                                                    imageSizeChange={true}
                                                                    labelImage="/ord?module://easyBinding/res/images/Left-ico.png"/>} </div>
                                                </div>
                                                <div style={{paddingRight: '1px'}} id="labelTop" className="btn"
                                                     onClick={event => this.state.labelTop()}>
                                                    <div style={{opacity: "0.5"}}
                                                         className="btn labelTop">{this.state.labelOnly === "true" ? null :
                                                        <ToolButton labelText={lex.get("eb.easyBinding.top")}
                                                                    useImage={true}
                                                                    selected={this.state.labelPos === "top" ? true : false}
                                                                    labelImage="/ord?module://easyBinding/res/images/Top-ico.png"/>}</div>
                                                </div>
                                                <div style={{paddingRight: '1px'}} id="labelBottom" className="btn"
                                                     onClick={event => this.state.labelBottom()}>
                                                    <div style={{opacity: "0.5"}}
                                                         className="btn labelBottom">{this.state.labelOnly === "true" ? null :
                                                        <ToolButton labelText={lex.get("eb.easyBinding.bottom")}
                                                                    useImage={true}
                                                                    selected={this.state.labelPos === "bottom" ? true : false}
                                                                    showRightSplitter={true}
                                                                    labelImage="/ord?module://easyBinding/res/images/Bottom-ico.png"/>}</div>
                                                </div>
                                                <div style={{paddingRight: '1px'}} id="labelRight" className="btn"
                                                     onClick={event => this.state.labelRight()}>
                                                    <div style={{opacity: "0.5"}}
                                                         className="btn labelRight">{this.state.labelOnly === "true" ? null :
                                                        <ToolButton labelText={lex.get("eb.easyBinding.right")}
                                                                    useImage={true}
                                                                    selected={this.state.labelPos === "right" ? true : false}
                                                                    imageSizeChange={true}
                                                                    labelImage="/ord?module://easyBinding/res/images/Right-ico.png"/>}</div>
                                                </div>
                                            </div> : null} </div> : null}

                                <div style={{marginRight: '5px'}}>
                                    {this.state.bindingButton === true && this.props.selected ?
                                        <div className="btn"
                                             onClick={event => this.state.clearBinding(this.state.labelText)}>
                                            <ToolButton labelText={lex.get("eb.easyBinding.delete")} useImage={true}
                                                        labelImage="/ord?module://easyBinding/res/images/Delete-ico.png"/>
                                        </div>
                                        :
                                        <div className="btn" onClick={this.buttonClicked}>
                                            <ToolButton labelText={lex.get("eb.easyBinding.add")} useImage={true}
                                                        labelImage="/ord?module://easyBinding/res/images/Add-ico.png"/>
                                        </div>}
                                </div>
                            </div>

                            {this.props.labelText !== "All" ?
                                <div style={{
                                    width: '100%',
                                    textAlign: 'left',
                                    display: 'flex',
                                    flexDirection: 'row',
                                    justifyContent: 'left',
                                    marginLeft: "5px"
                                }}>
                                    {this.state.bindingButton === true ? (this.props.selected ?
                                        <span className="overflow"
                                              style={{width: '200px'}}>{slotPath.unescape(this.props.pointName.substring(this.props.pointName.lastIndexOf('/') + 1))} </span>
                                        : '*Unbound*') : this.props.labelText}
                                </div> : null}
                        </div>
                        {
                            this.state.showPopup ?
                                <PointChooser dialogCloseHandler={this.popupDialogCloseHandler}/> : null
                        }

                    </div>
                );
            }
        });

        var BindingView = React.createClass({
            propTypes: {
                setLabelPosition: React.PropTypes.bool,
            },
            getDefaultProps: function () {
                return {
                    widgets: [],
                    pxSize: {w: "0", h: "0"},
                    save: () => {
                        /**
                         *
                         */
                    },
                    addLabelWidget: () => {
                        /**
                         *
                         */
                    },
                    toggleLabel: () => {
                        /**
                         *
                         */
                    },
                    toggleAlarm: () => {
                        /**
                         *
                         */
                    },
                    toggleOverride: () => {
                        /**
                         *
                         */
                    },
                    labelLeft: () => {
                        /**
                         *
                         */
                    },
                    labelRight: () => {
                        /**
                         *
                         */
                    },
                    labelTop: () => {
                        /**
                         *
                         */
                    },
                    labelBottom: () => {
                        /**
                         *
                         */
                    },
                    clearBinding: () => {
                        /**
                         *
                         */
                    },
                    revert: () => {
                        /**
                         *
                         */
                    },
                    undo: () => {
                        /**
                         *
                         */
                    },
                    lastUndoIndex: () => {
                        /**
                         *
                         */
                    },
                    pxOrd: "",
                    backgroundCanvas: null,
                    labelOnly: false,
                    undoIndex: [],
                    HighlightedSelectedToolbarAction: () => {
                        /**
                         *
                         */
                    },
                    addBinding: () => {
                        /**
                         *
                         */
                    },
                    setLabelPosition: false,
                    setDirty: () => {
                        /**
                         *
                         */
                    },
                    isDirty: false,
                    enableUndo: false,
                    setUndoEnable: () => {
                        /**
                         *
                         */
                    },
                    onWidgetSelected: () => {
                        /**
                         *
                         */
                    },
                    onOutsideClick: () => {
                        /**
                         *
                         */
                    },
                    selectedWidgetName: "",
                    selectedWidgetPath: "",
                }
            },

            getInitialState: function () {
                return {
                    widgets: this.props.widgets,
                    pxSize: this.props.pxSize,
                    save: this.props.save,
                    addLabelWidget: this.props.addLabelWidget,
                    toggleLabel: this.props.toggleLabel,
                    toggleAlarm: this.props.toggleAlarm,
                    toggleOverride: this.props.toggleOverride,
                    labelLeft: this.props.labelLeft,
                    labelRight: this.props.labelRight,
                    labelTop: this.props.labelTop,
                    labelBottom: this.props.labelBottom,
                    clearBinding: this.props.clearBinding,
                    revert: this.props.revert,
                    undo: this.props.undo,
                    id: this.props.id,
                    labelPos: this.props.labelPos,
                    showValue: this.props.showValue,
                    displayOverride: this.props.displayOverride,
                    showAlarm: this.props.showAlarm,
                    init: true,
                    valueOrd: this.props.valueOrd,
                    overrideOrd: this.props.overrideOrd,
                    alarmOrd: this.props.alarmOrd,
                    pxOrd: this.props.pxOrd,
                    showPopup: false,
                    backgroundCanvas: this.props.backgroundCanvas,
                    labelOnly: this.props.labelOnly,
                    lastUndoIndex: this.props.lastUndoIndex,
                    undoIndex: this.props.undoIndex,
                    HighlightedSelectedToolbarAction: this.props.HighlightedSelectedToolbarAction,
                    addBinding: this.props.addBinding,
                    setLabelPosition: this.props.setLabelPosition,
                    setDirty: this.props.setDirty,
                    isDirty: this.props.isDirty,
                    enableUndo: this.props.enableUndo,
                    setUndoEnable: this.props.setUndoEnable,

                    onWidgetSelected: this.props.onWidgetSelected,
                    onOutsideClick: this.props.onOutsideClick,
                    selectedWidgetName: this.props.selectedWidgetName,
                    selectedWidgetPath: this.props.selectedWidgetPath,

                }
            },

            componentWillReceiveProps: function (nextProps) {
                this.setState({
                    widgets: nextProps.widgets,
                    pxSize: nextProps.pxSize,
                    save: nextProps.save,
                    addLabelWidget: nextProps.addLabelWidget,
                    toggleLabel: nextProps.toggleLabel,
                    toggleAlarm: nextProps.toggleAlarm,
                    toggleOverride: nextProps.toggleOverride,
                    labelLeft: nextProps.labelLeft,
                    labelRight: nextProps.labelRight,
                    labelTop: nextProps.labelTop,
                    labelBottom: nextProps.labelBottom,
                    clearBinding: nextProps.clearBinding,
                    revert: nextProps.revert,
                    undo: nextProps.undo,
                    pxOrd: nextProps.pxOrd,
                    backgroundCanvas: nextProps.backgroundCanvas,
                    lastUndoIndex: nextProps.lastUndoIndex,
                    HighlightedSelectedToolbarAction: nextProps.HighlightedSelectedToolbarAction,
                    addBinding: nextProps.addBinding,
                    setLabelPosition: nextProps.setLabelPosition,
                    setDirty: nextProps.setDirty,
                    isDirty: nextProps.isDirty,
                    enableUndo: nextProps.enableUndo,
                    setUndoEnable: nextProps.setUndoEnable,
                    onWidgetSelected: nextProps.onWidgetSelected,
                    onOutsideClick: nextProps.onOutsideClick

                });
            },

            componentDidMount: function () {

            },
            componentDidUpdate(prevProps, prevState) {
                if (this.state.id !== prevState.id) {
                    this.state.HighlightedSelectedToolbarAction(this.state.labelPos);
                }
            },

            selectionChanged: function (id, labelPos, showValue, displayOverride, showAlarm, valueOrd, overrideOrd, alarmOrd, labelOnly, widgetName,widgetPath, widgetSelected) {
                this.setState({
                    id: id,
                    labelPos: labelPos,
                    showValue: showValue,
                    displayOverride: displayOverride,
                    showAlarm: showAlarm,
                    init: false,
                    valueOrd: valueOrd,
                    overrideOrd: overrideOrd,
                    alarmOrd: alarmOrd,
                    labelOnly: labelOnly,
                    selectedWidgetName: widgetName,
                    selectedWidgetPath: widgetPath,
                    setLabelPosition: true

                });
                this.state.onWidgetSelected(id);
                this.state.save();
            },
            lastWidgetIndexReceived: function (index) {
                this.state.undoIndex.push(index);
                this.state.setDirty(true);
                this.state.setUndoEnable(true);
                if (this.state.undoIndex.length > 5) { //allow undo till 5 last bound widget only
                    this.state.undoIndex.splice(0, 1); //remove oldest from array
                }
                this.state.save();

            },
            clickedOutsideOfWidget: function (event) {
                var isClickedOutSide = true;
                // Clear bounded ords if user clicked outside of Widget
                this.state.valueOrd = "";
                this.state.alarmOrd = "";
                this.state.overrideOrd = "";

                this.state.selectedWidgetName = "";
                this.state.selectedWidgetPath = "";

                const target = event.target;
                if (target.id === "editview" || target.id === "editcontainer" || target.id === "editviewDrag") {
                    this.state.onOutsideClick();
                }
            },
            render: function () {
                return (
                    <div id="bindingview" style={{
                        display: 'flex',
                        flexDirection: 'column',
                        flexWrap: 'nowrap',
                        justifyContent: 'space-evenly',
                        height: '100%'
                    }}>
                        <div className='widgetHeight'
                             style={{position: 'relative', flexShrink: '0', borderTop: '2px solid #EBEBEB'}}
                             onClick={this.clickedOutsideOfWidget}>

                            <EditView backgroundCanvas={this.state.backgroundCanvas} ref={(node) => {
                                this.editview = node;
                            }} addLabelWidget={this.state.addLabelWidget} init={this.state.init}
                                      widgetSelected={this.state.widgetSelected} pxOrd={this.state.pxOrd}
                                      pxContents={this.props.pxContents} widgets={this.state.widgets}
                                      pxSize={this.state.pxSize} selectedChanged={this.selectionChanged}
                                      lastWidgetIndex={this.lastWidgetIndexReceived}
                                      labelPos={this.state.labelPos} showValue={this.state.showValue}
                                      HighlightedSelectedToolbarAction={this.state.HighlightedSelectedToolbarAction}
                                      setLabelPosition={this.state.setLabelPosition}/>
                        </div>

                        <BindingToolbar id={this.state.id}
                                        labelPos={this.state.labelPos}
                                        showValue={this.state.showValue}
                                        displayOverride={this.state.displayOverride}
                                        showAlarm={this.state.showAlarm}
                                        save={this.state.save}
                                        toggleLabel={this.state.toggleLabel}
                                        toggleAlarm={this.state.toggleAlarm}
                                        toggleOverride={this.state.toggleOverride}
                                        labelLeft={this.state.labelLeft}
                                        labelRight={this.state.labelRight}
                                        labelTop={this.state.labelTop}
                                        labelBottom={this.state.labelBottom}
                                        clearBinding={this.state.clearBinding}
                                        revert={this.state.revert}
                                        undo={this.state.undo}
                                        valueOrd={this.state.valueOrd}
                                        overrideOrd={this.state.overrideOrd}
                                        alarmOrd={this.state.alarmOrd}
                                        labelOnly={this.state.labelOnly}
                                        undoIndex={this.state.undoIndex}
                                        HighlightedSelectedToolbarAction={this.state.HighlightedSelectedToolbarAction}
                                        addBinding={this.state.addBinding}
                                        isDirty={this.state.isDirty}
                                        enableUndo={this.state.enableUndo}
                                        selectedWidgetName={this.state.selectedWidgetName}
                                        selectedWidgetPath={this.state.selectedWidgetPath}
                        />
                    </div>
                );
            }
        });

        const EasyBinding = React.createClass({

            getInitialState: function () {
                return {

                    failedToLoadPx: false,
                    backgroundCanvas: null,
                    pointChooserConfig: null,
                    labelPos: this.props.labelPos,
                    showValue: this.props.showValue,
                    isDirty: false,
                    enableUndo: false,

                }
            },

            componentDidMount: function () {
                const that = this;

                that.set = setInterval(function () {
                    let widgetFound = true;
                    let i = 0;

                    //update pxfile for each widget
                    do {
                        if (that.bindingview !== undefined && that.bindingview.editview[`EasyBindingEdit${i}`] !== undefined) {
                            i++;
                        } else {
                            widgetFound = false;
                        }
                    } while (widgetFound === true)
                }, 1000);
            },

            createBackgroundImage: function () {
                const that = this;

                if (document.getElementById('capture') === null) {return false;}
                if (document.getElementById('myiframe') === null) {return false;}
                if (document.getElementById('myiframe').contentDocument.getElementById('root.content.scale') === null)
                {
                    return false;
                }

                document.getElementById('myiframe').contentDocument.getElementById('root.content.scale').style.transform = 'none';

                html2canvas(document.getElementById('myiframe').contentDocument.getElementById('root.content.scale'), {
                    logging: true,
                    scale: 1,
                    imageTimeout: 0
                }).then(canvas => {
                    that.setState({
                        backgroundCanvas: canvas
                    }, () => {
                        // callback func after image has been generated
                        that.checkAndUpdateBackground();
                    })
                });

                return true;
            },

            setPxOrd: function (ord) {
                const _This = this;

                _This.setState({
                    pxOrd: ord
                }, () => {
                    // make out iframe that we'll use to create the background image
                    const srcOrd = "/ord/" + this.state.pxOrd + "|view:hx:HxPxView?fullScreen=true";

                    const iframe = document.createElement('iframe');
                    iframe.id = "myiframe";
                    iframe.src = srcOrd;
                    $(iframe).css({'visibility': 'hidden'});
                    document.getElementsByTagName('body')[0].append(iframe);

                    _This.checkAndUpdateBackground();

                });
            },

            checkAndUpdateBackground: function () {
                const that = this;
                setTimeout(function () {
                    if (!that.createBackgroundImage()) {
                        that.checkAndUpdateBackground();
                    }
                }, 3000)
            },

            setPxContents: function (contents) {
                const _This = this;

                _This.setState({
                    pxContents: contents
                }, function () {
                    _This.forceUpdate();
                });
            },

            cannotLoadView: function () {
                this.setState({
                    failedToLoadPx: true
                });
            },

            parsePxFile: function (contents) {
                return EbUtils.parsePxFile(contents);
            },

            getPxSize: function (contents) {
                return EbUtils.getPxSize(contents);
            },

            toggleLabel: function (id) {
                this.bindingview.editview[`EasyBindingEdit${id}`].toggleLabel();
                this.save();
                this.setState({isDirty: true});
            },

            labelLeft: function (id) {
                this.bindingview.editview[`EasyBindingEdit${id}`].labelLeft();
                this.save();
                this.setState({isDirty: true});
            },

            labelRight: function (id) {

                this.bindingview.editview[`EasyBindingEdit${id}`].labelRight();
                this.save();
                this.setState({isDirty: true});
            },

            labelTop: function (id) {
                this.bindingview.editview[`EasyBindingEdit${id}`].labelTop();
                this.save();
                this.setState({isDirty: true});
            },

            labelBottom: function (id) {
                this.bindingview.editview[`EasyBindingEdit${id}`].labelBottom();
                this.save();
                this.setState({isDirty: true});
            },

            toggleAlarm: function (id) {
                this.bindingview.editview[`EasyBindingEdit${id}`].toggleAlarm();
                this.save();
                this.setState({isDirty: true});
            },

            toggleOverride: function (id) {
                this.bindingview.editview[`EasyBindingEdit${id}`].toggleOverride();
                this.save();
                this.setState({isDirty: true});
            },

            clearBinding: function (id, type) {
                this.bindingview.editview[`EasyBindingEdit${id}`].clearBinding(type);
                this.save();
                this.setState({isDirty: true});
            },

            addBinding: function (id, type, ord) {
                this.bindingview.editview[`EasyBindingEdit${id}`].addBinding(type, ord);
                this.HighlightedSelectedToolbarAction(this.bindingview.editview[`EasyBindingEdit${id}`].state.labelPos);
                this.save();
                this.setState({isDirty: true});
            },

            addLabelWidget: function (id, data, update) {
                const that = this;
                const newPxFile = update ? EbUtils.updateLabelInPxFile(id, data, this.state.pxContents) : EbUtils.addLabelToPxFile(id, data, this.state.pxContents);

                //make rpc call to update file
                baja.rpc({
                    typeSpec: "easyBinding:EasyBindingUtil",
                    method: "save",
                    args: [newPxFile, this.state.pxOrd]
                }).then(function (resp) {
                    sendLogBajaInfo(("The RPC response: ", resp), false);
                    that.setState({
                        pxContents: newPxFile
                    });
                }).error(function (err) {
                    sendLogBajaInfo(("rpc save error ..." + err), true);
                })
                this.setState({isDirty: true});
            },

            save: function () {

                // console.log("save => ", this.state.pxContents);
                // Access child component refs via parent component instance like this
                let newPxFile = this.state.pxContents;

                let widgetFound = true;
                let i = 0;
                const that = this;

                //update pxfile for each widget
                do {
                    if (this.bindingview !== undefined && this.bindingview.editview !== undefined
                        && this.bindingview.editview[`EasyBindingEdit${i}`] !== undefined) {

                        const data = this.bindingview.editview[`EasyBindingEdit${i}`].getData();

                        newPxFile = EbUtils.updatePxFile(i, data, newPxFile);

                        i++;
                    } else {
                        widgetFound = false;
                    }
                } while (widgetFound === true)

                if (newPxFile === undefined || newPxFile === null) {
                    return;
                }
                //make rpc call to update file
                baja.rpc({
                    typeSpec: "easyBinding:EasyBindingUtil",
                    method: "save",
                    args: [newPxFile, this.state.pxOrd]
                }).then(function (resp) {
                    sendLogBajaInfo(("The RPC response: ", resp), false);
                    that.setState({
                        pxContents: newPxFile
                    });
                }).error(function (err) {
                    sendLogBajaInfo(("rpc save error ..." + err), true);
                })
            },

            revertToOriginal: function () {
                let widgetFound = true;
                let i = 0;
                this.setState({isDirty: false});
                this.setUndoEnable(false);
                //update pxfile for each widget
                do {
                    if (this.bindingview !== undefined && this.bindingview.editview !== undefined && this.bindingview.editview[`EasyBindingEdit${i}`] !== undefined) {
                        this.setState({
                            valueOrd: null,
                            alarmOrd: null,
                            overrideOrd: null,
                        });
                        this.bindingview.editview[`EasyBindingEdit${i}`].reset();
                        document.getElementById(`EasyBindingEdit${i}`).style.visibility = "visible";
                        i++;
                    } else {
                        widgetFound = false;
                    }
                } while (widgetFound === true)

                this.save();
            },
            showBindingOverlay: function (id) {
                let i = 0;
                let currentTop = 0, currentLeft = 0, scrollHeight = 0, scrollWidth = 0;
                let top = 0, left = 0, sHeight = 0, sWidth = 0;
                const totalWidgets = document.getElementsByClassName("EasyBindingWidget").length;
                do {
                    if (this.bindingview !== undefined && this.bindingview.editview !== undefined &&
                        this.bindingview.editview[`EasyBindingEdit${i}`] !== undefined) {
                        this.bindingview.editview[`EasyBindingEdit${i}`].showBindingOverlay(i === id);
                        if (id === i && document.getElementById(`EasyBindingEdit${i}`) !== null) {
                                currentTop = parseInt(document.getElementById(`EasyBindingEdit${i}`).
                                style.top.replace("px", ""),10);
                                currentLeft = parseInt(document.getElementById(`EasyBindingEdit${i}`).
                                style.left.replace("px", ""),10);
                                scrollHeight = document.getElementById(`EasyBindingEdit${i}`).scrollHeight;
                                scrollWidth = document.getElementById(`EasyBindingEdit${i}`).scrollWidth;

                        }
                        i++;
                    }
                } while (i < totalWidgets)
                i = 0;
                do {
                    if (this.bindingview !== undefined && this.bindingview.editview !== undefined &&
                        this.bindingview.editview[`EasyBindingEdit${i}`] !== undefined) {
                        document.getElementById(`EasyBindingEdit${i}`) !== null ?
                            document.getElementById(`EasyBindingEdit${i}`).style.visibility = "visible" : null;
                        if (id !== i && document.getElementById(`EasyBindingEdit${i}`) !== null) {
                                top = parseInt(document.getElementById(`EasyBindingEdit${i}`).style.top.
                                replace("px", ""),10);
                                left = parseInt(document.getElementById(`EasyBindingEdit${i}`).style.left.
                                replace("px", ""),10);
                                sHeight = document.getElementById(`EasyBindingEdit${i}`).scrollHeight;
                                sWidth = document.getElementById(`EasyBindingEdit${i}`).scrollWidth;

                                if (EbUtils.isWidgetOverlapping(currentTop, currentLeft, scrollHeight, scrollWidth, top,
                                    left, sHeight, sWidth)) {
                                    document.getElementById(`EasyBindingEdit${i}`).style.visibility = "collapse";
                                }



                        }
                        i++;
                    }
                } while (i < totalWidgets)
            },
            showAllWidgets: function () {
                let i = 0;
                const totalWidgets = document.getElementsByClassName("EasyBindingWidget").length;
                if (this.bindingview !== undefined && this.bindingview.state !== undefined) {
                    this.bindingview.state.id = 0;
                }
                do {
                    if (this.bindingview !== undefined && this.bindingview.editview !== undefined
                        && this.bindingview.editview[`EasyBindingEdit${i}`] !== undefined) {
                        this.bindingview.editview[`EasyBindingEdit${i}`].showBindingOverlay(false);
                        if (document.getElementById(`EasyBindingEdit${i}`) !== null) {
                            document.getElementById(`EasyBindingEdit${i}`).style.visibility = "visible";
                        } else {
                            if (this.bindingview.editview[`EasyBindingEdit${i}`].isLabelWidget() === "true") {
                                const element = document.getElementById(`EasyBindingCustomEdit${i}`);
                                element.className.replace(" active", "");
                                element.style.background = 'white';
                                element.style.outline = 'none';
                            }
                        }
                    }
                    i++;
                } while (i < totalWidgets)
            },
            undoLastAction: function (id) {
                if (id > -1) {
                    let widgetFound = true;
                    let i = 0;
                    //update pxfile for each widget
                    do {
                        if (this.bindingview !== undefined && this.bindingview.editview !== undefined && this.bindingview.editview[`EasyBindingEdit${i}`] !== undefined) {
                            if (id === i) {
                                this.bindingview.editview[`EasyBindingEdit${i}`].reset();
                            }
                            i++;
                        } else {
                            widgetFound = false;
                        }
                    } while (widgetFound === true)

                    this.save();
                } else {
                    this.setUndoEnable(false);
                }

            },
            updatedLayout: function () {
                /**
                 *
                 */
            },

            togglePopup: function () {
                if (this.state.isDirty) {
                    this.setState({
                        showPopup: !this.state.showPopup
                    });
                }
            },
            setDirty: function (val) {
                this.setState({isDirty: val});
            },
            setUndoEnable: function (val) {
                this.setState({enableUndo: val});
            },
            revertPage: function (result) {
                const _This = this;

                switch (result) {
                    case "Continue": {
                        _This.revertToOriginal();
                        break;
                    }
                    case "Cancel": {
                        break;
                    }
                    default:{
                    break;
                    }
                }

                this.setState({showPopup: !this.state.showPopup});
            },
            HighlightedSelectedToolbarAction: function (labelPos) {
                if (labelPos !== undefined) {
                    const domL = document.getElementsByClassName("btn labelLeft");
                    const domR = document.getElementsByClassName("btn labelRight");
                    const domT = document.getElementsByClassName("btn labelTop");
                    const domB = document.getElementsByClassName("btn labelBottom");

                    switch (labelPos) {
                        case "left": {
                            for (let l = 0; l < domL.length; l++) {
                                domL[l].style.opacity = "1";
                                domR[l].style.opacity = "0.5";
                                domT[l].style.opacity = "0.5";
                                domB[l].style.opacity = "0.5";
                            }
                            break;
                        }
                        case "right": {
                            for (let r = 0; r < domL.length; r++) {
                                domL[r].style.opacity = "0.5";
                                domR[r].style.opacity = "1";
                                domT[r].style.opacity = "0.5";
                                domB[r].style.opacity = "0.5";
                            }
                            break;
                        }
                        case "top": {
                            for (let t = 0; t < domL.length; t++) {
                                domL[t].style.opacity = "0.5";
                                domR[t].style.opacity = "0.5";
                                domT[t].style.opacity = "1";
                                domB[t].style.opacity = "0.5";
                            }
                            break;
                        }
                        case "bottom": {
                            for (let b = 0; b < domL.length; b++) {
                                domL[b].style.opacity = "0.5";
                                domR[b].style.opacity = "0.5";
                                domT[b].style.opacity = "0.5";
                                domB[b].style.opacity = "1";
                            }
                            break;
                        }
                        default:{
                            break;
                        }
                    }
                }
            },
            render: function () {

                if (this.state.failedToLoadPx) {
                    return (
                        <div style={{
                            display: 'flex',
                            alignItems: 'center',
                            justifyContent: 'center',
                            height: "100%",
                            overflow: "hidden"
                        }}>
                            {lex.get("eb.easyBinding.failedToLoadPx")}
                        </div>
                    )
                } else if (this.state.pxContents === "NO_LICENSE") {
                    return (
                        <div style={{
                            display: 'flex',
                            alignItems: 'center',
                            justifyContent: 'center',
                            height: "100%",
                            overflow: "hidden"
                        }}>
                            {lex.get("eb.easyBinding.notLicensed")}
                        </div>
                    )
                } else if (this.state.pxContents === "EdgeController") {
                    return (
                        <div style={{
                            display: 'flex', alignItems: 'center', justifyContent: 'center', height: "100%",
                            overflow: "hidden"}}>
                            {lex.get("eb.easyBinding.notOnEdge")}
                        </div>
                    )
                } else {
                    if (this.state.pxContents === undefined) {
                        return (
                            <div style={{
                                display: 'flex', alignItems: 'center', justifyContent: 'center', height: "100%",
                                overflow: "hidden"
                            }}>
                                {lex.get("eb.easyBinding.loading")}
                            </div>
                        )
                    }
                }
                const widgets = this.parsePxFile(this.state.pxContents);
                const pxSize = this.getPxSize(this.state.pxContents);
                if (widgets.length === 0 && this.state.pxContents !== "NO_LICENSE") {
                    return (
                        <div style={{
                            display: 'flex', alignItems: 'center', justifyContent: 'center', height: "100%",
                            overflow: "hidden"
                        }}>
                            {lex.get("eb.easyBinding.noEasyBindingWidgetsPresentOnPxPage")}
                        </div>
                    )
                }
                return (
                    <div id="capture" style={{height: '100%', width: '100%'}}>
                        <div style={{
                            flexShrink: 1, display: 'flex', flexDirection: 'row', overflowY: 'hidden',
                            flexWrap: 'nowrap', height: '100%', width: '100%'
                        }}>
                            <div style={{flexGrow: '1'}}>
                                <BindingView ref={(node) => {
                                    this.bindingview = node;
                                }}
                                             pxOrd={this.state.pxOrd}
                                             pxContents={this.state.pxContents}
                                             widgets={widgets}
                                             id={widgets[0].index}
                                             labelPos={widgets[0].labelpos}
                                             showValue={widgets[0].showValue}
                                             displayOverride={widgets[0].showoverride}
                                             showAlarm={widgets[0].showalarm}
                                             valueOrd={""}
                                             overrideOrd={""}
                                             alarmOrd={""}
                                             save={this.save}
                                             addLabelWidget={this.addLabelWidget}
                                             pxSize={pxSize}
                                             toggleLabel={this.toggleLabel}
                                             toggleAlarm={this.toggleAlarm}
                                             toggleOverride={this.toggleOverride}
                                             labelLeft={this.labelLeft}
                                             labelRight={this.labelRight}
                                             labelTop={this.labelTop}
                                             labelBottom={this.labelBottom}
                                             clearBinding={this.clearBinding}
                                             revert={this.togglePopup}
                                             undo={this.undoLastAction}
                                             backgroundCanvas={this.state.backgroundCanvas}
                                             HighlightedSelectedToolbarAction={this.HighlightedSelectedToolbarAction}
                                             addBinding={this.addBinding}
                                             setDirty={this.setDirty}
                                             isDirty={this.state.isDirty}
                                             enableUndo={this.state.enableUndo}
                                             setUndoEnable={this.setUndoEnable}
                                             onWidgetSelected={this.showBindingOverlay}
                                             onOutsideClick={this.showAllWidgets}
                                />
                            </div></div>
                        {
                            this.state.showPopup ?
                                <Popup
                                    selectionMade={this.revertPage}
                                /> : null
                        }
                    </div>
                );
            }
        });

        return ReactDOM.render(<EasyBinding/>, element);
    }
});