define(['lex!easyBinding'], function (lexicons) {
    return function renderDOM(myD3, React, ReactDOM, height, width, dragDropUtils, baja, sendLogBajaInfo) {
        const lex = lexicons[0];

        const EasyWidget = React.createClass({

            propTypes: {
                width: React.PropTypes.string,
                height: React.PropTypes.string,
                x: React.PropTypes.string,
                y: React.PropTypes.string,
                index: React.PropTypes.number,
                selected: React.PropTypes.func,

                valueOrd: React.PropTypes.string,
                alarmOrd: React.PropTypes.string,
                overrideOrd: React.PropTypes.string,

                labelPos: React.PropTypes.string,
                showValue: React.PropTypes.bool,
                showAlarm: React.PropTypes.bool,
                showOverride: React.PropTypes.bool,
                showAll: React.PropTypes.bool,

                showPopup: React.PropTypes.bool,

                data: React.PropTypes.string,
                highlighted: React.PropTypes.bool,

                labelOnly: React.PropTypes.bool,
                labelMoved: React.PropTypes.func,
                currentWidgetIndex: React.PropTypes.func,
                options: React.PropTypes.array,

                widgetName: React.PropTypes.string,
                widgetPath: React.PropTypes.string,

                showBindOverlay: React.PropTypes.bool,
                dragEntered: React.PropTypes.bool,
                isImageDecoded: React.PropTypes.bool,
                decodedTrueImage: React.PropTypes.string,
                decodedFalseImage: React.PropTypes.string,
            },

            getDefaultProps: function () {
                return {
                    width: "50",
                    height: "50",
                    x: "0",
                    y: "0",
                    index: -1,
                    selected: () => {
                        /**
                         *
                         */
                    },

                    valueOrd: "null",
                    alarmOrd: "null",
                    overrideOrd: "null",

                    labelPos: "top",
                    showValue: true,
                    showAlarm: true,
                    showOverride: true,
                    showAll: true,

                    showPopup: false,

                    data: "{}",
                    highlighted: false,

                    labelOnly: false,
                    labelMoved: () => {
                        /**
                         *
                         */
                    },
                    currentWidgetIndex: () => {
                        /**
                         *
                         */
                    },
                    options: [],

                    widgetName: "",
                    widgetPath: "",
                    showBindOverlay: false,
                    dragEntered: false,
                    isImageDecoded: false,
                    decodedTrueImage: "",
                    decodedFalseImage: ""

                }
            },

            getInitialState: function () {
                return {
                    width: this.props.width,
                    height: this.props.height,
                    x: this.props.x,
                    y: this.props.y,
                    index: this.props.index,
                    selected: this.props.selected,

                    valueOrd: this.props.valueOrd,
                    alarmOrd: this.props.alarmOrd,
                    overrideOrd: this.props.overrideOrd,

                    labelPos: this.props.labelPos,
                    showAlarm: this.props.showAlarm,
                    showValue: this.props.showValue,
                    showAll: this.props.showAll,

                    showOverride: this.props.showOverride,

                    data: this.props.data,
                    highlighted: this.props.highlighted,


                    initialvalueOrd: this.props.valueOrd,
                    initialalarmOrd: this.props.alarmOrd,
                    initialoverrideOrd: this.props.overrideOrd,

                    initiallabelPos: this.props.labelPos,
                    initialshowAlarm: this.props.showAlarm,
                    initialshowValue: this.props.showValue,

                    initialshowOverride: this.props.showOverride,

                    initialdata: this.props.data,
                    initialhighlighted: this.props.highlighted,

                    labelOnly: this.props.labelOnly,
                    labelMoved: this.props.labelMoved,
                    currentWidgetIndex: this.props.currentWidgetIndex,
                    options: this.props.options,
                    widgetName: this.props.widgetName,
                    widgetPath: this.props.widgetPath,

                    showBindOverlay: this.props.showBindOverlay,
                    dragEntered: this.props.dragEntered,
                    decodedTrueImage: "",
                    decodedFalseImage: ""

                }
            },
            setFontSize: function (size, allLbl, alarmLbl, valLbl, ovLbl) {
                ovLbl.style.fontSize = size;
                alarmLbl.style.fontSize = size;
                valLbl.style.fontSize = size;
                allLbl.style.fontSize = size;
            },
            componentDidUpdate() {
                const lblOveride = document.getElementById("txtOverride");
                const lblValue = document.getElementById("txtValue");
                const lblAlarm = document.getElementById("txtAlarm");
                const lblAll = document.getElementById("txtAll");
                if (lblOveride !== null && lblOveride !== undefined) {
                    if (lblOveride.offsetWidth < 50) {
                        this.setFontSize("x-smaller", lblAll, lblAlarm, lblValue, lblOveride);
                    } else if (lblOveride.offsetWidth < 60) {
                        this.setFontSize("smaller", lblAll, lblAlarm, lblValue, lblOveride);
                    } else {
                        this.setFontSize("inherit", lblAll, lblAlarm, lblValue, lblOveride);
                    }
                }

            },
            componentWillReceiveProps: function (nextProps) {
                this.setState({
                    width: nextProps.width,
                    height: nextProps.height,
                    x: nextProps.x,
                    y: nextProps.y,
                    index: nextProps.index,
                    selected: nextProps.selected,

                    highlighted: nextProps.highlighted,


                    labelOnly: nextProps.labelOnly,
                    labelMoved: nextProps.labelMoved,
                    currentWidgetIndex: nextProps.currentWidgetIndex,

                    widgetName: nextProps.widgetName,
                    widgetPath: nextProps.widgetPath


                });
            },
            reset: function () {
                this.state.valueOrd = this.state.initialvalueOrd;
                this.state.alarmOrd = this.state.initialalarmOrd;
                this.state.overrideOrd = this.state.initialoverrideOrd;

                this.state.labelPos = this.state.initiallabelPos;
                this.state.showAlarm = this.state.initialshowAlarm;
                this.state.showValue = this.state.initialshowValue;

                this.state.showOverride = this.state.initialshowOverride;

                this.state.data = this.state.initialdata;
                this.state.labelOnly = this.state.labelOnly;
                this.state.labelMoved = this.state.labelMoved;
                this.state.currentWidgetIndex = this.state.currentWidgetIndex;
                this.state.isImageDecoded = false;
                this.checkAndUpdateToolbar();
            },

            showBindingOverlay: function (val) {
                this.setState({showBindOverlay: val});
            },

            checkAndUpdateToolbar: function () {
                this.state.selected(
                    this.state.index,
                    this.state.labelPos,
                    this.state.showValue,
                    this.state.showOverride,
                    this.state.showAlarm,
                    this.state.valueOrd,
                    this.state.overrideOrd,
                    this.state.alarmOrd,
                    this.state.labelOnly,
                    this.state.widgetName,
                    this.state.widgetPath
                );
            },


            markAsSelected: function (evt) {
                this.setActiveAndSetBorder(evt, this.state.index);
                this.state.selected(
                    this.state.index,
                    this.state.labelPos,
                    this.state.showValue,
                    this.state.showOverride,
                    this.state.showAlarm,
                    this.state.valueOrd,
                    this.state.overrideOrd,
                    this.state.alarmOrd,
                    this.state.labelOnly,
                    this.state.widgetName,
                    this.state.widgetPath
                );
            },

            setActiveAndSetBorder: function (evt, index) {
                // Declare all variables
                let widgets;
                // Get all elements with id="EasyBindingWidget" and remove the class selected
                widgets = document.getElementsByClassName("EasyBindingWidget");
                for (let i = 0; i < widgets.length; i++) {
                    widgets[i].className = widgets[i].className.replace(" active", "");
                    widgets[i].style.background = 'white';
                    widgets[i].style.outline = 'none';
                }
                if (this.state.labelOnly === "true") {
                    // Show the current tab, and add an "active" class to the button that opened the tab
                    evt.currentTarget.className += " active";
                    evt.currentTarget.style.background = '#F4F4F4';
                    evt.currentTarget.style.outline = '3px solid #00FF21';
                }
            },

            togglePopup: function (value, override, alarm) {
                this.setState({
                    showPopup: !this.state.showPopup,
                    valueOrd: value,
                    alarmOrd: alarm,
                    overrideOrd: override
                }, function () {
                    this.state.selected(
                        this.state.index,
                        this.state.labelPos,
                        this.state.showValue,
                        this.state.showOverride,
                        this.state.showAlarm,
                        this.state.valueOrd,
                        this.state.overrideOrd,
                        this.state.alarmOrd,
                        this.state.labelOnly,
                        this.state.widgetName,
                        this.state.widgetPath
                    );
                });
            },

            selectOrd: function (types) {
                const _This = this;
                let value = this.state.valueOrd;
                let override = this.state.overrideOrd;
                let alarm = this.state.alarmOrd;
                const newOrd = "station:|slot:/" + this.state.ord;

                if (types[0].indexOf("Value") > -1) {
                    if (value === "null" && this.state.showAlarm === "false" && this.state.showOverride === "false") {
                        this.state.showAlarm = "true";
                        this.state.showOverride = "true"
                    }
                    value = newOrd;
                }
                if (types[0].indexOf("Alarm") > -1) {
                    alarm = newOrd;
                }
                if (types[0].indexOf("Override") > -1) {
                    override = newOrd;
                }
                _This.togglePopup(value, override, alarm);
            },

            getData: function () {
                const data = {
                    index: this.state.index,
                    value: this.state.valueOrd,
                    alarm: this.state.alarmOrd,
                    override: this.state.overrideOrd,
                    showValue: this.state.showValue,
                    showalarm: this.state.showAlarm,
                    showoverride: this.state.showOverride,
                    labelposition: this.state.labelPos,
                    labelOnly: this.state.labelOnly
                };

                return data;
            },

            getImageOrdForDisplay: function () {
                const that = this;
                var config = this.state.data;
                const requestData = {
                    trueImage: config.trueImage,
                    falseImage: config.falseImage
                };
                if (!this.state.isImageDecoded) {
                    baja.rpc({
                        typeSpec: "easyBinding:EasyBindingUtil",
                        method: "getBase64Image",
                        args: [requestData]
                    }).then(function (resp) {
                        that.state.isImageDecoded = true;
                        that.state.decodedTrueImage = resp.trueImage;
                        that.state.decodedFalseImage = resp.falseImage;
                    }).error(function (err) {
                        sendLogBajaInfo("error in getting base64 image", false);
                    });
                }

                switch (config.bindingType) {
                    case "boolean":
                    case "generic":
                        var imgExt = (config.falseImage).split(".")[1];
                        const extensions = ["svg", "png", "jpg", "jpeg",
                            "gif", "tiff", "psd", "pdf", "eps", "ai", "indd", "raw"];
                        if (extensions.includes(imgExt)) {
                            return this.state.decodedFalseImage;
                        } else {
                            return this.state.decodedTrueImage;
                        }
                    default:
                        break;
                }
            },

            labelTop: function () {
                this.setState({
                    labelPos: 'top'
                }, function () {
                    this.state.selected(
                        this.state.index,
                        this.state.labelPos,
                        this.state.showValue,
                        this.state.showOverride,
                        this.state.showAlarm,
                        this.state.valueOrd,
                        this.state.overrideOrd,
                        this.state.alarmOrd,
                        this.state.labelOnly,
                        this.state.widgetName,
                        this.state.widgetPath
                    );
                });
            },

            labelBottom: function () {
                this.setState({
                    labelPos: 'bottom'
                }, function () {
                    this.state.selected(
                        this.state.index,
                        this.state.labelPos,
                        this.state.showValue,
                        this.state.showOverride,
                        this.state.showAlarm,
                        this.state.valueOrd,
                        this.state.overrideOrd,
                        this.state.alarmOrd,
                        this.state.labelOnly,
                        this.state.widgetName,
                        this.state.widgetPath
                    );
                });
            },

            labelLeft: function () {
                this.setState({
                    labelPos: 'left'
                }, function () {
                    this.state.selected(
                        this.state.index,
                        this.state.labelPos,
                        this.state.showValue,
                        this.state.showOverride,
                        this.state.showAlarm,
                        this.state.valueOrd,
                        this.state.overrideOrd,
                        this.state.alarmOrd,
                        this.state.labelOnly,
                        this.state.widgetName,
                        this.state.widgetPath
                    );
                });
            },

            labelRight: function () {
                this.setState({
                    labelPos: 'right'
                }, function () {
                    this.state.selected(
                        this.state.index,
                        this.state.labelPos,
                        this.state.showValue,
                        this.state.showOverride,
                        this.state.showAlarm,
                        this.state.valueOrd,
                        this.state.overrideOrd,
                        this.state.alarmOrd,
                        this.state.labelOnly,
                        this.state.widgetName,
                        this.state.widgetPath
                    );
                });
            },

            toggleLabel: function () {
                if (!(this.state.valueOrd === "" || this.state.valueOrd === "null")) {
                    this.setState({
                        showValue: this.state.showValue === "false" ? "true" : "false"
                    }, function () {
                        this.state.selected(
                            this.state.index,
                            this.state.labelPos,
                            this.state.showValue,
                            this.state.showOverride,
                            this.state.showAlarm,
                            this.state.valueOrd,
                            this.state.overrideOrd,
                            this.state.alarmOrd,
                            this.state.labelOnly,
                            this.state.widgetName,
                            this.state.widgetPath
                        );
                    });
                }
            },

            toggleAlarm: function () {
                if (!(this.state.alarmOrd === "" || this.state.alarmOrd === "null")) {
                    this.setState({
                        showAlarm: this.state.showAlarm === "false" ? "true" : "false"
                    }, function () {
                        this.state.selected(
                            this.state.index,
                            this.state.labelPos,
                            this.state.showValue,
                            this.state.showOverride,
                            this.state.showAlarm,
                            this.state.valueOrd,
                            this.state.overrideOrd,
                            this.state.alarmOrd,
                            this.state.labelOnly,
                            this.state.widgetName,
                            this.state.widgetPath
                        );
                    });
                }
            },

            toggleOverride: function () {
                if (!(this.state.overrideOrd === "" || this.state.overrideOrd === "null")) {
                    this.setState({
                        showOverride: this.state.showOverride === "false" ? "true" : "false"
                    }, function () {
                        this.state.selected(
                            this.state.index,
                            this.state.labelPos,
                            this.state.showValue,
                            this.state.showOverride,
                            this.state.showAlarm,
                            this.state.valueOrd,
                            this.state.overrideOrd,
                            this.state.alarmOrd,
                            this.state.labelOnly,
                            this.state.widgetName,
                            this.state.widgetPath
                        );
                    });
                }

            },
            toggleAll: function () {
                if ((this.state.valueOrd !== "" && this.state.valueOrd !== "null") &&
                    (this.state.alarmOrd !== "" && this.state.alarmOrd !== "null") &&
                    (this.state.overrideOrd !== "" && this.state.overrideOrd !== "null")) {
                    this.setState({
                        showAll: this.state.showAll === "false" ? "true" : "false",
                        showValue: this.state.showAll === "false" ? "true" : "false",
                        showAlarm: this.state.showAll === "false" ? "true" : "false",
                        showOverride: this.state.showAll === "false" ? "true" : "false",
                    }, function () {
                        this.state.selected(
                            this.state.index,
                            this.state.labelPos,
                            this.state.showValue,
                            this.state.showOverride,
                            this.state.showAlarm,
                            this.state.valueOrd,
                            this.state.overrideOrd,
                            this.state.alarmOrd,
                            this.state.labelOnly,
                            this.state.widgetName,
                            this.state.widgetPath
                        );
                    });
                }
            },

            addBinding: function (type, ord) {
                const _This = this;
                let value = this.state.valueOrd;
                let override = this.state.overrideOrd;
                let alarm = this.state.alarmOrd;
                const newOrd = "station:|slot:/" + ord;
                switch (type[0]) {
                    case "Value": {
                        value = newOrd;
                        break;
                    }
                    case "Alarm": {
                        alarm = newOrd;
                        break;
                    }
                    case "Override": {
                        override = newOrd;
                        break;
                    }
                    case "All": {
                        value = newOrd;
                        alarm = newOrd;
                        override = newOrd;
                        break;
                    }
                    default: {
                        break;
                    }
                }
                this.state.currentWidgetIndex(_This.state.index);
                this.setState({
                    valueOrd: value,
                    alarmOrd: alarm,
                    overrideOrd: override
                }, function () {
                    this.state.selected(
                        this.state.index,
                        this.state.labelPos,
                        this.state.showValue,
                        this.state.showOverride,
                        this.state.showAlarm,
                        this.state.valueOrd,
                        this.state.overrideOrd,
                        this.state.alarmOrd,
                        this.state.labelOnly,
                        this.state.widgetName,
                        this.state.widgetPath
                    );
                });
            },

            clearBinding: function (type) {
                let value = this.state.valueOrd;
                let override = this.state.overrideOrd;
                let alarm = this.state.alarmOrd;

                switch (type) {
                    case "Value": {
                        value = "null";
                        this.state.showAlarm = "false";
                        this.state.showOverride = "false";
                        break;
                    }
                    case "Alarm": {
                        alarm = "null";
                        break;
                    }
                    case "Override": {
                        override = "null";
                        break;
                    }
                    case "All": {
                        value = "null";
                        alarm = "null";
                        override = "null";
                        break;
                    }
                    default: {
                        break;
                    }
                }

                this.setState({
                    valueOrd: value,
                    alarmOrd: alarm,
                    overrideOrd: override
                }, function () {
                    this.state.selected(
                        this.state.index,
                        this.state.labelPos,
                        this.state.showValue,
                        this.state.showOverride,
                        this.state.showAlarm,
                        this.state.valueOrd,
                        this.state.overrideOrd,
                        this.state.alarmOrd,
                        this.state.labelOnly,
                        this.state.widgetName,
                        this.state.widgetPath
                    );
                });
            },


            dragEnter: function (ev) {
                ev.preventDefault();
            },

            dragOver: function (ev) {
                this.showBindingOverlay(true);
                this.setState({dragEntered: true});
                ev.preventDefault();
            },

            dragLeave: function (ev) {
                const _This = this;
                this.setState({dragEntered: false});
                _This.markAsSelected(ev);
            },

            isLabelWidget: function () {
                return this.state.labelOnly;
            },

            dragEnd: function () {
                this.setState({dragEntered: false});
            },

            onDrop: function (ev) {
                const _This = this;
                this.setState({dragEntered: false});
                _This.markAsSelected(ev);
            },

            dragAndDrop: function (ev, selectedVal) {
                const _This = this;
                let data = "";
                ev.preventDefault();
                ev.stopPropagation();
                this.setState({dragEntered: false});
                ev.dataTransfer.setData("dropped", "true");
                const p1 = dragDropUtils.fromClipboard(ev.dataTransfer).then(function (envelope) {
                        return envelope.toJson().then(function (json) {
                            if (json !== undefined && json.length > 0) {
                                const firstObj = json[0];
                                if (firstObj.typeSpec.includes("Boolean") || firstObj.typeSpec.includes("Numeric") || firstObj.typeSpec.includes("Enum")) {
                                    data = firstObj.ord;
                                    data = data.substring(data.indexOf("|slot:/") + 7);
                                    return Promise.resolve(data);
                                }
                            }
                        });
                    }
                );
                p1.then(function (val) {
                    const pointOrd = val;
                    if (pointOrd !== undefined && pointOrd !== "") {
                        _This.setState({
                            ord: pointOrd,
                        });
                        _This.addBinding([selectedVal], pointOrd);
                    }
                    _This.markAsSelected(ev);
                });
            },

            onDragStop: function (ev) {
                ev.dataTransfer.setData("label", this.state.labelOnly === "true" ? "true" : "false");
                ev.dataTransfer.setData("move", true);
                ev.dataTransfer.setData("moveIndex", this.state.index);
                if (this.state.labelOnly === "true") {
                    ev.dataTransfer.setData("ord", this.state.valueOrd);
                }
                this.setState({dragEntered: false});
            },

            render: function () {
                const id = (this.state.labelOnly ? "EasyBindingCustomEdit" : "EasyBindingEdit") + this.state.index;
                const imagesrc = this.getImageOrdForDisplay();

                const defaultEasyBindingWidgetStyle = {
                    whiteSpace: 'pre',
                    position: 'absolute',
                    left: this.state.y,
                    top: this.state.x,
                    height: this.state.height + "px",
                    width: this.state.labelOnly ? null : this.state.width + "px",
                    outlineOffset: '1px'
                }

                const additionalEasyBindingWidgetStyle = {};
                let className = "EasyBindingWidget";
                if (this.state.index === 0 && this.state.highlighted === true) {
                    className += " active";
                }

                let overlayEmptyBind;
                let overlayBind;
                const isEmpty = (this.state.valueOrd === "" || this.state.valueOrd === "null") &&
                    (this.state.alarmOrd === "" || this.state.alarmOrd === "null") &&
                    (this.state.overrideOrd === "" || this.state.overrideOrd === "null");

                const isAllBind = (this.state.valueOrd !== "" && this.state.valueOrd !== "null") &&
                    (this.state.alarmOrd !== "" && this.state.alarmOrd !== "null") &&
                    (this.state.overrideOrd !== "" && this.state.overrideOrd !== "null");

                const isPartialBind = (this.state.valueOrd !== "" && this.state.valueOrd !== "null") ||
                    (this.state.alarmOrd !== "" && this.state.alarmOrd !== "null") ||
                    (this.state.overrideOrd !== "" && this.state.overrideOrd !== "null");

                overlayEmptyBind = (
                    <div style={{display: 'flex', flexDirection: 'column', justifyContent: 'center', height: '100%'}}>
                        <div style={{display: 'flex', justifyContent: 'center'}}>
                            <img src={"/ord?module://easyBinding/res/images/Easy Binding Editor Broken.png"}/>
                        </div>
                    </div>
                );

                const isHideAll = (this.state.showValue === "false" && this.state.showAlarm === "false" && this.state.showOverride === "false");

                let eyeImg;
                if (isHideAll) {
                    eyeImg = <img style={{width: '20px', objectFit: 'scale-down', align: 'middle', filter: 'invert(1)'}}
                                  src={"/ord?module://easyBinding/res/images/Hide-ico.png"}/>
                } else {
                    eyeImg = <img style={{width: '20px', objectFit: 'scale-down', align: 'middle', filter: 'invert(1)'}}
                                  src={"/ord?module://easyBinding/res/images/Show-ico.png"}/>
                }
                ;

                overlayBind = (
                    this.state.showBindOverlay ?
                        <div className={"overlayOnWidget"} style={{width: '100%', position: 'relative', left: '0%'}}>
                            <div style={{display: 'flex', width: '100%'}} onClick={event => this.toggleLabel()}
                                 onDrop={(e) => this.dragAndDrop(e, "Value")} style={{
                                width: '100%',
                                border: '2px solid #7E7F7E',
                                background: this.state.valueOrd === "" || this.state.valueOrd === "null" ? null : '#000000',
                                opacity: '1',
                                color: this.state.valueOrd === "" || this.state.valueOrd === "null" ? 'black' : 'white'
                            }}>
                                <table style={{width: "100%"}}>
                                    <tr>
                                        <td style={{width: "5%"}}>
                                            {!(this.state.valueOrd === "" || this.state.valueOrd === "null") ?
                                                <div style={{float: 'left', width: '30%', marginLeft: '5%'}}>
                                                    {this.state.showValue === "true" ?
                                                        <img style={{
                                                            width: '20px',
                                                            objectFit: 'scale-down',
                                                            align: 'middle',
                                                            filter: 'invert(1)'
                                                        }} src={"/ord?module://easyBinding/res/images/Show-ico.png"}/>
                                                        : <img style={{
                                                            width: '20px',
                                                            objectFit: 'scale-down',
                                                            align: 'middle',
                                                            filter: 'invert(1)'
                                                        }}
                                                               src={"/ord?module://easyBinding/res/images/Hide-ico.png"}/>}</div>
                                                : null}
                                        </td>
                                        <td id={"txtValue"} style={{width: "95%", textAlign: "center"}}>
                                            <div
                                                style={!(this.state.valueOrd === "" || this.state.valueOrd === "null") ? {
                                                    width: '70%',
                                                    display: 'contents'
                                                } : {
                                                    width: '100%',
                                                    textAlign: 'center'
                                                }}> {lex.get("eb.easyBinding.value")} </div>
                                        </td>
                                    </tr>
                                </table>
                            </div>

                            <div style={{display: 'flex'}} onClick={event => this.toggleAlarm()}
                                 onDrop={(e) => this.dragAndDrop(e, "Alarm")} style={{
                                width: '100%',
                                'border-left': '2px solid #7E7F7E',
                                'border-right': '2px solid #7E7F7E',
                                'border-bottom': '2px solid #7E7F7E',
                                background: this.state.alarmOrd === "" || this.state.alarmOrd === "null" ? null : '#D80000',
                                opacity: '1',
                                color: this.state.alarmOrd === "" || this.state.alarmOrd === "null" ? 'black' : 'white'
                            }}>
                                <table style={{width: "100%"}}>
                                    <tr>
                                        <td style={{width: "5%"}}>
                                            {!(this.state.alarmOrd === "" || this.state.alarmOrd === "null") ?
                                                <div style={{float: 'left', width: '30%', marginLeft: '5%'}}>
                                                    {this.state.showAlarm === "true" ?
                                                        <img style={{
                                                            width: '20px',
                                                            objectFit: 'scale-down',
                                                            align: 'middle',
                                                            filter: 'invert(1)'
                                                        }} src={"/ord?module://easyBinding/res/images/Show-ico.png"}/>
                                                        : <img style={{
                                                            width: '20px',
                                                            objectFit: 'scale-down',
                                                            align: 'middle',
                                                            filter: 'invert(1)'
                                                        }}
                                                               src={"/ord?module://easyBinding/res/images/Hide-ico.png"}/>}</div> : null}
                                        </td>
                                        <td id={"txtAlarm"} style={{width: "95%", textAlign: "center"}}>
                                            <div
                                                style={!(this.state.alarmOrd === "" || this.state.alarmOrd === "null") ? {
                                                    width: '70%',
                                                    display: 'contents'
                                                } : {
                                                    width: '100%',
                                                    textAlign: 'center'
                                                }}> {lex.get("eb.easyBinding.alarm")} </div>
                                        </td>
                                    </tr>
                                </table>
                            </div>

                            <div style={{display: 'flex'}} onClick={event => this.toggleOverride()}
                                 onDrop={(e) => this.dragAndDrop(e, "Override")} style={{
                                width: '100%',
                                'border-left': '2px solid #7E7F7E',
                                'border-right': '2px solid #7E7F7E',
                                'border-bottom': '2px solid #7E7F7E',
                                background: this.state.overrideOrd === "" || this.state.overrideOrd === "null" ? null : '#BF96CB',
                                opacity: '1',
                                color: this.state.overrideOrd === "" || this.state.overrideOrd === "null" ? 'black' : 'white'
                            }}>
                                <table style={{width: "100%"}}>
                                    <tr>
                                        <td style={{width: "5%"}}>
                                            {!(this.state.overrideOrd === "" || this.state.overrideOrd === "null") ?
                                                <div style={{float: 'left', width: '30%', marginLeft: '5%'}}>
                                                    {this.state.showOverride === "true" ?
                                                        <img style={{
                                                            width: '20px',
                                                            objectFit: 'scale-down',
                                                            align: 'middle',
                                                            filter: 'invert(1)'
                                                        }} src={"/ord?module://easyBinding/res/images/Show-ico.png"}/>
                                                        : <img style={{
                                                            width: '20px',
                                                            objectFit: 'scale-down',
                                                            align: 'middle',
                                                            filter: 'invert(1)'
                                                        }}
                                                               src={"/ord?module://easyBinding/res/images/Hide-ico.png"}/>}</div> : null}
                                        </td>
                                        <td id="txtOverride" style={{width: "95%", textAlign: "center"}}>
                                            <div
                                                style={!(this.state.overrideOrd === "" || this.state.overrideOrd === "null") ? {
                                                    width: '70%',
                                                    display: 'contents'
                                                } : {
                                                    width: '100%',
                                                    textAlign: 'center'
                                                }}> {lex.get("eb.easyBinding.override")} </div>
                                        </td>
                                    </tr>
                                </table>
                            </div>

                            {
                                !this.state.showBindOverlay ? null :
                                    <div style={{display: 'flex'}} onClick={event => this.toggleAll()}
                                         onDrop={(e) => this.dragAndDrop(e, "All")} style={{
                                        width: '100%',
                                        'border-left': '2px solid #7E7F7E',
                                        'border-right': '2px solid #7E7F7E',
                                        'border-bottom': '2px solid #7E7F7E',
                                        background: 'white',
                                        opacity: '1'
                                    }}>
                                        <table style={{width: "100%"}}>
                                            <tr>
                                                <td style={{width: "5%"}}>
                                                    {isAllBind ?
                                                        <div style={{float: 'left', width: '30%', marginLeft: '5%'}}>
                                                            {eyeImg}
                                                        </div> : null}
                                                </td>
                                                <td id={"txtAll"} style={{width: "95%", textAlign: "center"}}>
                                                    <div style={isAllBind ? {width: '70%', display: 'contents'} : {
                                                        width: '100%',
                                                        textAlign: 'center'
                                                    }}> {lex.get("eb.easyBinding.all")} </div>
                                                </td>
                                            </tr>
                                        </table>
                                    </div>
                            }
                        </div> : null
                );

                return (
                    <div id={id} draggable={this.state.labelOnly === "true" ? "true" : "false"} className={className}
                         style={Object.assign({}, defaultEasyBindingWidgetStyle, additionalEasyBindingWidgetStyle)}
                         onClick={this.markAsSelected}
                         onDragEnter={this.dragEnter}
                         onDragOver={this.dragOver}
                         onDragLeave={this.dragLeave}
                         onDragStart={this.onDragStop}
                         onDragEnd={this.dragEnd}
                         onDrop={this.onDrop}
                    >
                        {this.state.labelOnly === "true" ? null :
                            <div id="widgetBorder" className={this.state.showBindOverlay ? 'widget-border' : ''}>
                                <div style={{width: '100%', height: '100%', position: 'relative'}}>
                                    <span style={{
                                        display: 'flex',
                                        flexDirection: 'row',
                                        justifyContent: 'center',
                                        paddingBottom: '10px'
                                    }}>{this.state.widgetName}</span>
                                    <img style={{width: '100%', height: '100%'}} src={imagesrc}/>
                                    {
                                        isEmpty ? <div style={{
                                            width: '100%',
                                            height: '100%',
                                            position: 'absolute',
                                            top: '0',
                                            left: '0'
                                        }}>{overlayEmptyBind}</div> : null
                                    }
                                </div>
                                <div style={{marginTop: '6px'}}>{overlayBind}</div>
                            </div>
                        }
                        {
                            this.state.labelOnly === "true" ?
                                <div style={{
                                    width: '100%',
                                    height: '100%',
                                    position: 'relative',
                                    display: 'flex',
                                    flexDirection: 'row',
                                    flexWrap: 'nowrap',
                                    justifyContent: 'flexStart'
                                }}>
                                    <div style={{
                                        flexGrow: 1,
                                        display: 'flex',
                                        justifyContent: 'center',
                                        flexDirection: 'column'
                                    }}>{lex.get("eb.easyBinding.easyBindingLabel")}</div>
                                </div> : null
                        }
                    </div>
                );
            }
        });

        return EasyWidget;
    }
});
