define(['lex!easyBinding'], function (lexicons) {
    return function renderDOM(React, ReactDOM, baja,slotPath, sendLogBajaInfo, LeftFilterPanel, SearchTree) {
        const lex = lexicons[0];

        const PointChooser = React.createClass({

            getDefaultProps: function () {
                return {
                    rememberLastChk: false,
                    treeObjects: [],
                    pointChooserConfig: null,
                    supervisorIcon: "",
                    filterBoolean: true,
                    filterSecureBoolean: true,
                    filterNumeric: true,
                    filterSecureNumeric: true,
                    filterEnum: true,
                    filterSecureEnum: true,
                    currentSearchText: "",
                    lastSearchText: "",
                    updateTree: true,
                    selectedPath: "",
                    typingTimer: null,
                    doneTypingInterval: 500,
                    collapseAll: false,
                    loadingTree: false,
                    maxWaitTime: 5000,
                    selParent: ""
                }
            },

            getInitialState: function () {
                return {
                    rememberLastChk: this.props.rememberLastChk,
                    supervisorIcon: this.props.supervisorIcon,
                    filterBoolean: this.props.filterBoolean,
                    filterSecureBoolean: this.props.filterSecureBoolean,
                    filterNumeric: this.props.filterNumeric,
                    filterSecureNumeric: this.props.filterSecureNumeric,
                    filterEnum: this.props.filterEnum,
                    filterSecureEnum: this.props.filterSecureEnum,
                    currentSearchText: this.props.currentSearchText,
                    lastSearchText: this.props.lastSearchText,
                    updateTree: this.props.updateTree,
                    selectedPath: this.props.selectedPath,
                    typingTimer: this.props.typingTimer,
                    doneTypingInterval: this.props.doneTypingInterval,
                    collapseAll: this.props.collapseAll,
                    loadingTree: this.props.loadingTree,
                    maxWaitTime: this.props.maxWaitTime,
                    selParent:this.props.selParent
                }
            },

            getSupervisorIcon: function () {
                const that = this;
                baja.rpc({
                    typeSpec: "easyBinding:EasyBindingUtil",
                    method: "getSupervisorIcon"
                }).then(function (resp) {
                    if (resp !== undefined) {
                        that.setState({supervisorIcon: resp});
                    }
                }).error(function (err) {
                    sendLogBajaInfo(("rpc save error ..." + err), true);
                })
                return "";
            },

            getNavTreeItems: function () {
                const that = this;
                that.setState({loadingTree: true});
                baja.rpc({
                    typeSpec: "easyBinding:EasyBindingUtil",
                    method: "getNavTree"
                }).then(function (resp) {
                    that.setState({
                        treeObjects: resp.response,
                    }, function () {
                        const waitTime = that.state.pointChooserConfig != null? 1000 : 200;
                        setTimeout(function () {
                            that.setState({loadingTree: false}, function () {
                            });
                            let s= that.state.pointChooserConfig !== null ? that.state.pointChooserConfig.lastSearchText : "";
                            let selPoint = that.state.pointChooserConfig.lastSelectedPoint;
                            if(that.state.rememberLastChk){
                                selPoint = selPoint.substring(selPoint.lastIndexOf('/')+1);
                                s =slotPath.unescape(selPoint);
                            }
                            that.updateSearchTextValue(s,that.state.pointChooserConfig.lastSelectedPoint);
                        }, waitTime);
                    });
                }).error(function (err) {
                    sendLogBajaInfo(("rpc save error ..." + err), true);
                    that.setState({loadingTree: false});
                });
                //Close wait spinner if keeps moving more than max time
                setTimeout(function () {
                    if (that.state.loadingTree) {
                        that.setState({loadingTree: false});
                    }

                }, that.state.maxWaitTime);
                return [];
            },

            getLastChecked: function () {
                const that = this;
                baja.rpc({
                    typeSpec: "easyBinding:EasyBindingUtil",
                    method: "getPointChooserConfig"
                }).then(function (resp) {
                    if (resp !== undefined) {
                        if (resp.lastSelectedPoint !== "") {
                            that.filterBooleanPoints(resp.lastBooleanCheckboxValue !== undefined ? resp.lastBooleanCheckboxValue : true);
                            that.filterSecureBooleanPoints(resp.lastSecureBooleanCheckboxValue !== undefined ? resp.lastSecureBooleanCheckboxValue : true);
                            that.filterSecureNumericPoints(resp.lastSecureNumericCheckboxValue !== undefined ? resp.lastSecureNumericCheckboxValue : true);
                            that.filterNumericPoints(resp.lastNumericCheckboxValue !== undefined ? resp.lastNumericCheckboxValue : true);
                            that.filterSecureEnumPoints(resp.lastSecureEnumCheckboxValue !== undefined ? resp.lastSecureEnumCheckboxValue : true);
                            that.filterEnumPoints(resp.lastEnumCheckboxValue !== undefined ? resp.lastEnumCheckboxValue : true);
                            that.setState({
                                rememberLastChk: resp.lastSelectedPoint !== "", pointChooserConfig: resp
                            });
                        } else {
                            that.setState({
                                rememberLastChk: resp.lastSelectedPoint !== ""
                            });
                        }
                    }
                }).error(function (err) {
                    sendLogBajaInfo(("rpc save error ..." + err), true);
                })
                return [];
            },
            updateSearchTextValue: function (val,selPoint) {
                document.getElementById("txtSearchText").value = val.trim();
                if (document.getElementById("txtSearchText").value !== "") {
                    document.getElementById("txtSearchText").style.background = 'none'
                    this.setState({currentSearchText: val.trim(), updateTree: true,selParent:selPoint});
                }
            },
            componentDidMount: function () {
                const that = this;
                that.getSupervisorIcon();
                that.getLastChecked();
                that.getNavTreeItems();
            },

            handleChangeChk: function () {
                this.setState({
                    rememberLastChk: !this.state.rememberLastChk,
                });
            },

            pointCanceled: function (event) {
                const returnData = {
                    buttonType: "Cancel"
                }
                this.props.dialogCloseHandler(returnData);
            },

            pointSelected: function (event) {
                const that = this;

                const requestData = {
                    lastSearchText: that.state.rememberLastChk ? that.state.currentSearchText : "",
                    lastBooleanCheckboxValue: that.state.filterBoolean,
                    lastNumericCheckboxValue: that.state.filterNumeric,
                    lastEnumCheckboxValue: that.state.filterEnum,
                    lastSecureBooleanCheckboxValue: that.state.filterSecureBoolean,
                    lastSecureNumericCheckboxValue: that.state.filterSecureNumeric,
                    lastSecureEnumCheckboxValue: that.state.filterSecureEnum,
                    lastSelectedFolder: "",
                    lastSelectedPoint: that.state.rememberLastChk ? that.state.selectedPath : ""
                }

                const returnData = {
                    buttonType: "Ok",
                    rememberLastChoice: false,
                    lastChoiceSavedSuccessful: false,
                    selectedPointOrd: that.state.selectedPath,
                }
                returnData.rememberLastChoice = that.state.rememberLastChk;
                baja.rpc({
                    typeSpec: "easyBinding:EasyBindingUtil",
                    method: "savePointChooserConfig",
                    args: [requestData]
                }).then(function (resp) {
                    returnData.lastChoiceSavedSuccessful = true;
                    that.props.dialogCloseHandler(returnData);
                }).error(function (err) {
                    returnData.lastChoiceSavedSuccessful = false;
                    that.props.dialogCloseHandler(returnData);
                });
            },
            filterBooleanPoints: function (event) {
                this.setState({filterBoolean: event});
                this.setState({
                    currentSearchText: this.state.currentSearchText + " ",
                    updateTree: true,
                    collapseAll: false
                });
            },
            filterSecureBooleanPoints: function (event) {
                this.setState({filterSecureBoolean: event});
                this.setState({
                    currentSearchText: this.state.currentSearchText + " ",
                    updateTree: true,
                    collapseAll: false
                });
            },
            filterNumericPoints: function (event) {
                this.setState({filterNumeric: event});
                this.setState({
                    currentSearchText: this.state.currentSearchText + " ",
                    updateTree: true,
                    collapseAll: false
                });
            },
            filterSecureNumericPoints: function (event) {
                this.setState({filterSecureNumeric: event});
                this.setState({
                    currentSearchText: this.state.currentSearchText + " ",
                    updateTree: true,
                    collapseAll: false
                });
            },
            filterEnumPoints: function (event) {
                this.setState({filterEnum: event});
                this.setState({
                    currentSearchText: this.state.currentSearchText + " ",
                    updateTree: true,
                    collapseAll: false
                });
            },
            filterSecureEnumPoints: function (event) {
                this.setState({filterSecureEnum: event});
                this.setState({
                    currentSearchText: this.state.currentSearchText + " ",
                    updateTree: true,
                    collapseAll: false
                });
            },
            updateSearch: function (e) {
                clearTimeout(this.state.typingTimer);
                const that = this;
                this.state.typingTimer = setTimeout(function () {
                        that.setState({lastSearchText: that.state.currentSearchText,selParent:""});
                        that.setState({
                            currentSearchText: document.getElementById("txtSearchText").value.trim(),
                            updateTree: true,
                            collapseAll: document.getElementById("txtSearchText").value === ""
                        });
                    }, this.state.doneTypingInterval
                );
            },
            onTextChange: function (e) {
                const targetValue = e.target.value;
                if (targetValue.trim() !== "") {
                    e.target.style.background = 'none';
                    if (this.state.pointChooserConfig.lastSelectedPoint !== "") {
                        this.state.pointChooserConfig.lastSelectedPoint = "";
                    }
                } else {
                    if (e.target.style.background === 'none') {
                        e.target.style.background = 'white url("/ord?module://easyBinding/res/images/searchImage.png") left no-repeat';
                    }
                }
            },
            onKeydown: function (e) {
                clearTimeout(this.state.typingTimer);
            },
            setSelectedOrd: function (ordSelected) {
                if (this.state.selectedPath.trim() !== ordSelected.trim()) {
                    this.setState({selectedPath:  ordSelected});
                }
            },
            dragEnter: function (ev) {
                ev.preventDefault();
            },
            onDrop: function (event) {
                event.preventDefault();
                const move = event.dataTransfer.getData("popupMove");
                if (move) {
                    const position = $('#popupDivId').parent().offset();
                    const y = (event.clientX - position.left);
                    const x = (event.clientY - position.top);
                    $("#popupDivId").parent().css({top: x, left: y});
                }
            },
            onMove: function (ev) {
                ev.dataTransfer.setData("popupMove", true);
            },
            getSpinner: function () {
                return (this.state.loadingTree ?
                        <div><img style={{
                            width: '90px',
                            objectFit: 'scale-down',
                            position: 'absolute',
                            opacity: '0.95',
                            align: 'middle'
                        }} src={"/ord?module://easyBinding/res/images/spinner.gif"}/></div> : ""
                );
            },
            waitHandler: function(flag){
                if(flag!==this.state.loadingTree) {
                    this.setState({loadingTree: flag});
                }
            },
            render() {
                const filterConfig = {
                    filterBoolean: this.state.filterBoolean,
                    filterSecureBoolean: this.state.filterSecureBoolean,
                    filterNumeric: this.state.filterNumeric,
                    filterSecureNumeric: this.state.filterSecureNumeric,
                    filterEnum: this.state.filterEnum,
                    filterSecureEnum: this.state.filterSecureEnum
                };

                if (this.state.currentSearchText !== this.state.lastSearchText && this.state.updateTree) {
                    this.setState({lastSearchText: this.state.currentSearchText, updateTree: false});
                }
                return (
                    <div onDragEnter={this.dragEnter} onDragOver={this.dragEnter} onDrop={this.onDrop} style={{
                        position: 'fixed',
                        width: '100%',
                        height: '100%',
                        top: 0,
                        left: 0,
                        right: 0,
                        bottom: 0,
                        margin: 'auto',
                        backgroundColor: 'rgba(0, 0, 0, 0.5)',
                        zIndex: '999999'
                    }}>
                        <div style={{
                            position: 'absolute',
                            left: 'calc(100% - 75%)',
                            right: 'calc(100% - 75%)',
                            top: 'calc(100% - 65%)',
                            bottom: 'calc(100% - 75%)',
                            margin: 'auto',
                            background: 'transparent',
                            width: '100%',
                            height: '100%',
                        }}>
                            <div id="popupDivId" draggable={true} onDragStart={this.onMove}
                                 className="js-dialog ux-fg ux-shadow ux-border" style={{
                                overflow: 'auto',
                                top: 0,
                                left: 0,
                                right: 0,
                                bottom: 0,
                                border: '2px solid #A6A6A6'
                            }}>
                                <div style={{display: 'flex', flexDirection: 'row', paddingTop: '2px'}}>
                                    <img style={{
                                        marginLeft: '5px',
                                        marginTop: '3px',
                                        align: 'right',
                                        height: '24px',
                                        width: '24px'
                                    }} src={this.state.supervisorIcon}/>
                                    <span style={{
                                        width: '520px',
                                        marginLeft: '10px',
                                        marginTop: '5px',
                                        cursor: 'move',
                                        fontFamily: 'Calibri !important',
                                        color: '#000000',
                                        fontSize: '16px'
                                    }}>{lex.get("eb.easyBinding.pointChooser")}</span>

                                    <img style={{align: 'right'}}
                                         src='/ord?module://easyBinding/res/images/close-ico.png'
                                         onClick={(e) => this.pointCanceled(e)}/></div>
                                <div style={{
                                    paddingLeft: '10px',
                                    paddingRight: '10px',
                                    paddingTop: '5px',
                                    paddingBottom: '1px'
                                }}>
                                    <div style={{height: '370px', width: '100%', maxWidth: '568px'}}>
                                        <div className="Row" style={{height: '100%', width: '100%'}}>
                                            <div className="Cell" style={{width: '30%', border: '1px solid #7F7F7F'}}>
                                                <LeftFilterPanel filterConfig={filterConfig}
                                                                 booleanChecked={this.filterBooleanPoints}
                                                                 secureBooleanChecked={this.filterSecureBooleanPoints}
                                                                 numericChecked={this.filterNumericPoints}
                                                                 secureNumericChecked={this.filterSecureNumericPoints}
                                                                 enumChecked={this.filterEnumPoints}
                                                                 secureEnumChecked={this.filterSecureEnumPoints}/>
                                            </div>
                                            <div className="Cell" style={{width: '70%'}}>
                                                <div style={{
                                                    display: 'flex',
                                                    flexDirection: 'column',
                                                    height: '100%',
                                                    width: '100%'
                                                }}>
                                                    <div style={{
                                                        display: 'flex',
                                                        flexDirection: 'column',
                                                        height: '16%',
                                                        width: '100%',
                                                        border: '1px solid black'
                                                    }}>
                                                        <div style={{
                                                            height: '50%',
                                                            borderBottom: '1px solid black',
                                                            backgroundColor: '#696F79',
                                                            color: 'white',
                                                            paddingLeft: '10px',
                                                            paddingTop: '5px',
                                                            fontSize: '14px'
                                                        }}>{lex.get("eb.easyBinding.currentPath")}</div>
                                                        <input style={{
                                                            height: '50%',
                                                            paddingLeft: '10px',
                                                            color: '#000000',
                                                            fontSize: '14px'
                                                        }} type="text" value={slotPath.unescape(this.state.selectedPath)}/>
                                                    </div>
                                                    <input style={{
                                                        height: '8%',
                                                        width: '98%',
                                                        border: '2px solid #BFBFBF',
                                                        marginTop: '5px',
                                                        marginBottom: '3px'
                                                    }}

                                                           type="text" id="txtSearchText" onKeydown={this.onKeydown}
                                                           onKeyUp={this.updateSearch} onPaste={this.updateSearch}
                                                           onChange={this.onTextChange}
                                                           placeholder={"       " + lex.get("eb.easyBinding.points.filter.search")}
                                                           autocomplete="off"/>
                                                    <div style={{
                                                        height: '76%',
                                                        width: '100%',
                                                        marginTop: '2px',
                                                        borderTop: '1px solid #7F7F7F',
                                                        borderBottom: '1px solid #7F7F7F',
                                                        borderRight: '1px solid #7F7F7F',
                                                        backgroundColor: '#F9F9F9',
                                                        color: '#3D3D3D',
                                                        fontSize: '12px'
                                                    }}>
                                                        <div style={{
                                                            position: 'absolute',
                                                            top: '40%',
                                                            left: '50%'
                                                        }}>{this.getSpinner()}</div>
                                                        <SearchTree items={this.state.treeObjects}
                                                                    pointChooserConfig={this.state.pointChooserConfig}
                                                                    filterBoolean={this.state.filterBoolean}
                                                                    filterSecureBoolean={this.state.filterSecureBoolean}
                                                                    filterNumeric={this.state.filterNumeric}
                                                                    filterSecureNumeric={this.state.filterSecureNumeric}
                                                                    filterEnum={this.state.filterEnum}
                                                                    filterSecureEnum={this.state.filterSecureEnum}
                                                                    currentSearchText={this.state.currentSearchText}
                                                                    lastSearchText={this.state.lastSearchText}
                                                                    updateTree={this.state.updateTree}
                                                                    selectedOrdNotify={this.setSelectedOrd}
                                                                    allowFolderSelect={false}
                                                                    collapseAll={this.state.collapseAll}
                                                                    notifyWait={this.waitHandler}
                                                                    selParent={this.state.selParent}
                                                        />

                                                    </div>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                                <div className="js-dialog-button-content"
                                     style={{display: 'flex', flexDirection: 'row', textAlign: 'left'}}>
                                    <div style={{width: '48%', color: '#000000', fontSize: '14px'}}>
                                        <input style={{marginLeft: '15px', marginTop: '15px'}} type="checkbox"
                                               id="valueId" checked={this.state.rememberLastChk}
                                               onChange={this.handleChangeChk}/>
                                        <span style={{
                                            color: '#000000',
                                            fontSize: '14px'
                                        }}>&nbsp;&nbsp;{lex.get("eb.easyBinding.rememberLastChoice")}</span></div>
                                    <button className="ebButton" onClick={(e) => this.pointSelected(e)}
                                            type="button">{lex.get("eb.easyBinding.choose")}</button>
                                    <button className="ebButton" onClick={(e) => this.pointCanceled(e)}
                                            type="button">{lex.get("eb.easyBinding.cancel")}</button>
                                </div>
                            </div>
                        </div>
                    </div>

                );
            }
        });

        return PointChooser;
    }
});